#include "animation.h"

void ani_deactivateObject(u16 object)
{
	ani_objects[object].active = 0;
}

void ani_activateObject(u16 object)
{
	ani_objects[object].active = 1;
}

void ani_deactivateSwap(u16 object)
{
	u16 i = 0;
	for(i = 0; i < ani_objectSwapCnt; i++)
	{
		if(ani_objectswap[i].object == object && ani_objectswap[i].active==1)
		{
			ani_objectswap[i].active=0;
			return;
		}
	}
}

void ani_activateSwap(u16 animation)
{
	ani_deactivateSwap(ani_objectswap[animation].object);
	ani_objectswap[animation].active = 1;
}

void ani_deactivateMove(u16 object)
{
	u16 i = 0;
	for(i = 0; i < ani_objectMoveCnt; i++)
	{
		if(ani_objectmove[i].object == object && ani_objectmove[i].active==1)
		{
			ani_objectmove[i].active=0;
			return;
		}
	}
}

void ani_activateMove(u16 animation)
{
	ani_deactivateMove(ani_objectmove[animation].object);
	ani_objectmove[animation].active = 1;
}

void ani_drawObjects(void)
{
	u16 i=0; 
	
	for(i =0; i < ani_objectCnt; i++)
	{
		
		if(ani_objects[i].update&ANI_UPDATE_FULL)
		{
			WORLD_HEAD(ani_objects[i].bgMap,WRLD_ON | WRLD_BGMAP | ani_objects[i].charSeq);
			WORLD_GSET(ani_objects[i].bgMap,ani_objects[i].x,ani_objects[i].p,ani_objects[i].y);
			WORLD_MSET(ani_objects[i].bgMap,ani_objects[i].mx,ani_objects[i].mp,ani_objects[i].my);
			WORLD_SIZE(ani_objects[i].bgMap,ani_objects[i].w,ani_objects[i].h);
			
			if(ani_objects[i].type == ANI_TYPE_FIXED)
			{
				ani_objects[i].update = ANI_UPDATE_NONE;
			}
			else if(ani_objects[i].type == ANI_TYPE_MOVING_A)
			{
				ani_objects[i].update = ANI_UPDATE_POS | ANI_UPDATE_SPRITE;
			}
			else if(ani_objects[i].type == ANI_TYPE_MOVING)
			{
				ani_objects[i].update = ANI_UPDATE_POS;
			}
			else if(ani_objects[i].type == ANI_TYPE_ANIMATED)
			{
				ani_objects[i].update = ANI_UPDATE_SPRITE;
			}
		}
	
		if(ani_objects[i].active==1)
		{
		
			if(ani_objects[i].update&ANI_UPDATE_POS)
			{
				WORLD_GSET(ani_objects[i].bgMap,ani_objects[i].x,ani_objects[i].p,ani_objects[i].y);
				//WORLD_GSET(ani_objects[i].bgMap,ani_objects[i].x,ani_objects[i].p,ani_objects[i].y);
				//WORLD_MSET(ani_objects[i].bgMap,ani_objects[i].mx,ani_objects[i].mp,ani_objects[i].my);
			}
			
			if(ani_objects[i].update&ANI_UPDATE_SPRITE)
			{
				
				WORLD_MSET(ani_objects[i].bgMap,ani_objects[i].mx,ani_objects[i].mp,ani_objects[i].my);
			}
		}
		
	}
	
	if(ani_lastScreen>0)
	{
		WORLD_HEAD(ani_lastScreen, WRLD_END);
	}
}

void ani_moveObjects(void)
{
	u16 i=0; 
	
	for(i = 0; i < ani_objectMoveCnt; i++)
	{
		if(ani_objectmove[i].active == 1)
		{
			if(ani_objectmove[i].delay > 0)
			{
				ani_objectmove[i].delay--;
			}
			else if(ani_objectmove[i].type==ANI_MOVE_JUMP)
			{
				ani_objects[ani_objectmove[i].object].x = ani_objectmove[i].target_x;
				ani_objects[ani_objectmove[i].object].y = ani_objectmove[i].target_y;
				ani_objects[ani_objectmove[i].object].p = ani_objectmove[i].target_p;
				ani_objectmove[i].active = 0;
			}
			else if(ani_objectmove[i].type==ANI_MOVE_STRAIGHT)
			{
				u8 xDone=0;
				u8 pDone=0;
				u8 yDone=0;
			
			
				if(ani_objects[ani_objectmove[i].object].x - ani_objectmove[i].speed_x >= ani_objectmove[i].target_x)
				{
					ani_objects[ani_objectmove[i].object].x = ani_objects[ani_objectmove[i].object].x - ani_objectmove[i].speed_x;
				}
				else if (ani_objects[ani_objectmove[i].object].x + ani_objectmove[i].speed_x <= ani_objectmove[i].target_x)
				{
					ani_objects[ani_objectmove[i].object].x = ani_objects[ani_objectmove[i].object].x + ani_objectmove[i].speed_x;
				}
				else
				{
					xDone = 1;
				}
				
				if(ani_objects[ani_objectmove[i].object].y - ani_objectmove[i].speed_y >= ani_objectmove[i].target_y)
				{
					ani_objects[ani_objectmove[i].object].y = ani_objects[ani_objectmove[i].object].y - ani_objectmove[i].speed_y;
				}
				else if (ani_objects[ani_objectmove[i].object].y + ani_objectmove[i].speed_y <= ani_objectmove[i].target_y)
				{
					ani_objects[ani_objectmove[i].object].y = ani_objects[ani_objectmove[i].object].y + ani_objectmove[i].speed_y;
				}
				else
				{
					yDone=1;
				}
				
				if(ani_objects[ani_objectmove[i].object].p - ani_objectmove[i].speed_p >= ani_objectmove[i].target_p)
				{
					ani_objects[ani_objectmove[i].object].p = ani_objects[ani_objectmove[i].object].p - ani_objectmove[i].speed_p;
				}
				else if (ani_objects[ani_objectmove[i].object].p + ani_objectmove[i].speed_p <= ani_objectmove[i].target_p)
				{
					ani_objects[ani_objectmove[i].object].p = ani_objects[ani_objectmove[i].object].p + ani_objectmove[i].speed_p;
				}
				else
				{
					pDone=1;
				}
				
				if(yDone==1 && xDone==1 && pDone ==1)
				{
					if(ani_objectmove[i].mode==ANI_MOVE_MODE_LOOP)
					{
						ani_objects[ani_objectmove[i].object].x = ani_objectmove[i].start_x;
						ani_objects[ani_objectmove[i].object].y = ani_objectmove[i].start_y;
						ani_objects[ani_objectmove[i].object].p = ani_objectmove[i].start_p;
					}
					else if(ani_objectmove[i].mode==ANI_MOVE_MODE_STAY)
					{
						ani_objects[ani_objectmove[i].object].update = ANI_UPDATE_NONE;
						ani_objectmove[i].active = 0;
					}
					else if(ani_objectmove[i].mode==ANI_MOVE_MODE_IGNORE)
					{
						//ani_objects[ani_objectmove[i].object].update = ANI_UPDATE_NONE;
						ani_deactivateMove(ani_objectmove[i].object);
						ani_deactivateObject(ani_objectmove[i].object);
						ani_deactivateSwap(ani_objectmove[i].object);
						//ani_objectmove[i].active = 0;
						//ani_objectswap[ani_objectmove[i].object].active = 0;
						//ani_objects[ani_objectmove[i].object].active = 0;
					}
					else if(ani_objectmove[i].mode==ANI_MOVE_MODE_ACTIVE)
					{
						//ani_objects[ani_objectmove[i].object].update = ANI_UPDATE_NONE;
						ani_objectmove[i].active = 0;
					}
				}
				
			}
		}
	}
}

void ani_swapObjects(void)
{
	u16 i=0; 
	
	for(i = 0; i < ani_objectSwapCnt; i++)
	{
		if(ani_objectswap[i].active == 1)
		{
			if(ani_objectswap[i].delay > 0)
			{
				ani_objectswap[i].delay--;
			}
			else if(ani_objectswap[i].action == ANI_SWAP_NONE)
			{
				ani_objects[ani_objectswap[i].object].mx = ani_objectswap[i].new_mx;
				ani_objects[ani_objectswap[i].object].mp = ani_objectswap[i].new_mp;
				ani_objects[ani_objectswap[i].object].my = ani_objectswap[i].new_my;
				ani_objectswap[i].active=0;
			}
			else if(ani_objectswap[i].action == ANI_SWAP_BACK)
			{
				ani_objectswap[i].old_mx = ani_objects[ani_objectswap[i].object].mx;
				ani_objectswap[i].old_mp = ani_objects[ani_objectswap[i].object].mp;
				ani_objectswap[i].old_my = ani_objects[ani_objectswap[i].object].my;
				
				ani_objects[ani_objectswap[i].object].mx = ani_objectswap[i].new_mx;
				ani_objects[ani_objectswap[i].object].mp = ani_objectswap[i].new_mp;
				ani_objects[ani_objectswap[i].object].my = ani_objectswap[i].new_my;
				ani_objectswap[i].delay = ani_objectswap[i].duration;
				
				ani_objectswap[i].active=1;
				ani_objectswap[i].new_mx = ani_objectswap[i].old_mx;
				ani_objectswap[i].new_mp = ani_objectswap[i].old_mp;
				ani_objectswap[i].new_my = ani_objectswap[i].old_my;
				
			}
			else if(ani_objectswap[i].action == ANI_SWAP_SWITCH)
			{
				ani_objects[ani_objectswap[i].object].mx = ani_objectswap[i].new_mx;
				ani_objects[ani_objectswap[i].object].mp = ani_objectswap[i].new_mp;
				ani_objects[ani_objectswap[i].object].my = ani_objectswap[i].new_my;
				ani_objectswap[i].active=0;
				ani_objectswap[ani_objectswap[i].next].delay = ani_objectswap[i].duration;
				//ani_objectswap[i].delay = ani_objectswap[i].duration;
				//ani_objectswap[ani_objectswap[i].next].delay = ani_objectswap[ani_objectswap[i].next].duration;
				ani_objectswap[ani_objectswap[i].next].active=1;
			}
		}
	}
}



void ani_rotateObjects(void)
{
	u16 i=0;

	for(i = 0; i < ani_objectRotateCnt; i++)
	{
		if(ani_objectrotate[i].type== ANI_ROTATE_CW)
		{
			
			
			
		}
	}
}

