
#define ANI_UPDATE_NONE		0x00
#define ANI_UPDATE_FULL		0x01
#define ANI_UPDATE_POS		0x02
#define ANI_UPDATE_SPRITE	0x04

#define ANI_TYPE_FIXED		0x00
#define ANI_TYPE_MOVING		0x01
#define ANI_TYPE_MOVING_A	0x02
#define ANI_TYPE_ANIMATED	0x03

#define ANI_MOVE_STRAIGHT		0x00
#define ANI_MOVE_JUMP			0x01

#define ANI_MOVE_MODE_STAY		0x00
#define ANI_MOVE_MODE_LOOP		0x01
#define ANI_MOVE_MODE_IGNORE	0x02
#define ANI_MOVE_MODE_ACTIVE    0x03

#define ANI_SWAP_NONE		0x00
#define ANI_SWAP_BACK		0x01
#define ANI_SWAP_SWITCH		0x02

#define ANI_ROTATE_CW	0x00
#define ANI_ROTATE_CCW	0x01

typedef struct {
	u16  mx;
	u16  mp;
	u16  my;
	u16 w;
	u16 h;
	s16 x;
	s16 p;
	s16 y;
	u8 charSeq;
	u8 bgMap;
	u8 update;
	u8 type;
	u8 active;
} object;

typedef struct {
	s16 target_x;
	s16 target_p;
	s16 target_y;
	u8 speed_x;
	u8 speed_p;
	u8 speed_y;
	u16 delay;
	u8 type;
	u8 object;
	u8 mode;
	s16 start_x;
	s16 start_p;
	s16 start_y;
	u8  active;
} movement;

typedef struct {
	u16 new_mx;	
	u16 new_mp;
	u16 new_my;
	u16 old_mx;
	u16 old_mp;
	u16 old_my;
	u16 delay;
	u16 duration;
	u8  active;
	u8  object;
	u8  action;
	u8  next;
} swap;

typedef struct {
	s16 target_angle;
	u8 speed;
	u16 delay;
	u8 object;
	u8 type;
} rotation;

u16 ani_objectCnt = 0;
u16 ani_objectMoveCnt = 0;
u16 ani_objectSwapCnt = 0;
u16 ani_objectRotateCnt = 0;
s8 ani_lastScreen = 0;

object * ani_objects;
movement * ani_objectmove;
rotation * ani_objectrotate;
swap * ani_objectswap;

void ani_moveObjects(void);
void ani_rotateObjects(void);
void ani_drawObjects(void);
void ani_swapObjects(void);