#include "./libgccvb/libgccvb.h"
#include "fishbone.h"

#include "player/midiPlayer.c"
#include "music/inv3v01c.h"
#include "music/inv3v03d.h"
#include "music/inv3v10g.h"
#include "music/inv3v12a.h"
#include "music/inv3v13a.h"
#include "music/inv3v15h.h"
#include "music/underfx.h"
#include "music/techno.h"

#include "sfx/sounddat.h"  

#include "animation.c"
#include "textutil.c"

#include "screens/game.h"	

#include "screens/enginescreen.c"
#include "screens/startmenu.c"
#include "screens/levelmenu.c"
#include "screens/gameover.c"
#include "screens/level1.c"
#include "screens/level2.c"
#include "screens/level3.c"
#include "screens/level4.c"
#include "screens/adjust.c"
#include "screens/credits.c"

#include "fonts/fontChar.h"

#include "img/stuffchar.h"
#include "img/stuffmap.h"


u8 status = STATUS_ADJUSTSCREEN;
//u8 status = STATUS_LEVELSCREEN;
//u8 status = STATUS_LEVEL1;
//u8 status = STATUS_STARTSCREEN;

const char sig[17] = "I hate teenagers";

int main()
{
	
	HWORD pad;
	
	main_setUpSRAM(1);
	
	copymem ((void*)CharSeg3, (void*)FONT, 8192);
	copymem((void*)CharSeg3, (void*)STUFFCHAR, 6192); 
	copymem((void*)BGMap(3), (void*)STUFFMAP,  6192);
	
	mp_init();
	
	/*
	mp_playerStop();
	//mp_loadSong_inv3v01c(); //startmenu
	//mp_loadSong_inv3v03d(); //levelmenu
	//mp_loadSong_inv3v10g(); //level 1
	//mp_loadSong_inv3v12a(); //credits 
	//mp_loadSong_inv3v13a(); //level 4
	//mp_loadSong_inv3v15h(); //level 3
	mp_loadSong_underfx();    //level 2
	mp_playerStart();
	*/
	
	vbDisplayOn();
	vbDisplayHide();
	
	while(1)
	{
		
		if(status==STATUS_ADJUSTSCREEN)
		{
			ad_setUpScreen();
			status = ad_display(pad);
			
			if(status!=STATUS_ADJUSTSCREEN)
			{
				ad_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
			}
		}
		else if(status==STATUS_ENGINESCREEN)
		{
			es_setUpScreen();
			status = es_display(pad);
			
			if(status!=STATUS_ENGINESCREEN)
			{
				es_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
				
			}
		}
		else if(status==STATUS_STARTSCREEN)
		{
			sm_setUpScreen();
			status = sm_display(pad);
			
			if(status!=STATUS_STARTSCREEN)
			{
				mp_playerStop();
				sm_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
			}
		}
		else if(status==STATUS_LEVELSCREEN)
		{
			lm_setUpScreen();
			status = lm_display(pad);
			
			if(status!=STATUS_LEVELSCREEN)
			{
				mp_playerStop();
				lm_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
			}
		}
		else if(status==STATUS_LEVEL1)
		{
			l1_startUp();
			l1_setUpScreen();
			status = l1_display(pad);
			
			if(status!=STATUS_LEVEL1)
			{
				mp_playerStop();
				l1_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
				
			}
		}
		else if(status==STATUS_LEVEL2)
		{
			l2_startUp();
			l2_setUpScreen();
			status = l2_display(pad);
			
			if(status!=STATUS_LEVEL2)
			{
				mp_playerStop();
				l2_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
				
			}
		}
		else if(status==STATUS_LEVEL3)
		{
			l3_startUp();
			l3_setUpScreen();
			status = l3_display(pad);
			
			if(status!=STATUS_LEVEL3)
			{
				mp_playerStop();
				l3_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
				
			}
		}
		else if(status==STATUS_LEVEL4)
		{
			l4_startUp();
			l4_setUpScreen();
			status = l4_display(pad);
			
			if(status!=STATUS_LEVEL4)
			{
				mp_playerStop();
				l4_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
				
			}
		}
		else if(status==STATUS_GAMEOVERSCREEN)
		{
			go_setUpScreen();
			status = go_display(pad);
			
			if(status!=STATUS_GAMEOVERSCREEN)
			{
				mp_playerStop();
				go_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
				
			}
		}
		else if(status==STATUS_CREDITS)
		{
			ce_startUp();
			ce_setUpScreen();
			status = ce_display(pad);
			
			if(status!=STATUS_CREDITS)
			{
				mp_playerStop();
				ce_reset();
				WORLD_HEAD(31, WRLD_END);
				vbDisplayHide();
			}
		}
		
		pad = vbReadPad(); 	//get buttons
		
		if(main_pause==0)
		{
			ani_swapObjects();
			ani_moveObjects();	
			//ani_rotateObjects();
			ani_drawObjects();
		}
		
		suse_doSounds();
		
		vbWaitFrame(0);		//sync 
	}
    
    return 0;
}
