#include "../img/goscreenmap.h"
#include "../img/goscreenchar.h"

#define SM_OBJ_FISH  0
#define SM_OBJ_BONE1 1
#define SM_OBJ_BONE2 2
#define SM_OBJ_BONE3 3
#define SM_OBJ_BONE4 4
#define SM_OBJ_BONE5 5

u16 go_screenLoaded = 0;

u16 go_objectCount = 6;
u16 go_objectSwapCount = 20;
u16 go_objectMoveCount = 12;
u8 go_lastScreen = 24;
char go_overText[10] = "GAME OVER";

object go_objects[6] = {{0,0,40, 38,50, 173,0,-60, 0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  // FISH
						{ 0,0,0, 39,35, 410,0,120,  0, 29, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},// bone 1
						{ 0,0,0, 39,35, 410,0,120,  0, 28, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},// bone 2
						{ 0,0,0, 39,35, 410,0,120,  0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},// bone 3
						{ 0,0,0, 39,35, 410,0,120,  0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},// bone 4
						{ 0,0,0, 39,35, 410,0,120,  0, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},// bone 5
						};  	
						
movement go_objectmove[12] = {{173,0,120, 1,1,5, 0,ANI_MOVE_STRAIGHT,SM_OBJ_FISH,3, 0,0,0, 1},
							 {173,0,-60, 1,1,1, 38,ANI_MOVE_JUMP,SM_OBJ_FISH,3, 0,0,0, 1},
							 {173,0,120, 1,1,1, 38,ANI_MOVE_JUMP,SM_OBJ_BONE1,3, 0,0,0, 1},
							 {173,0,-60, 1,1,5, 38,ANI_MOVE_STRAIGHT,SM_OBJ_BONE1,3, 0,0,0, 1},
							 {173,0,120, 1,1,1, 38,ANI_MOVE_JUMP,SM_OBJ_BONE2,3, 0,0,0, 1},
							 {410,0,120, 5,1,0, 38,ANI_MOVE_STRAIGHT,SM_OBJ_BONE2,3, 0,0,0, 1},
							 {173,0,120, 1,1,1, 38,ANI_MOVE_JUMP,SM_OBJ_BONE3,3, 0,0,0, 1},
							 {-60,0,120, 5,1,0, 38,ANI_MOVE_STRAIGHT,SM_OBJ_BONE3,3, 0,0,0, 1},
							 {173,0,120, 1,1,1, 38,ANI_MOVE_JUMP,SM_OBJ_BONE4,3, 0,0,0, 1},
							 {-60,0,-60, 5,1,5, 38,ANI_MOVE_STRAIGHT,SM_OBJ_BONE4,3, 0,0,0, 1},
							 {173,0,120, 1,1,1, 38,ANI_MOVE_JUMP,SM_OBJ_BONE5,3, 0,0,0, 1},
							 {410,0,-60, 5,1,5, 38,ANI_MOVE_STRAIGHT,SM_OBJ_BONE5,3, 0,0,0, 1},
							 };
							 
swap go_objectswap[20] = {{0,0,0, 0,0,0, 39, 2, 1, SM_OBJ_BONE1,  ANI_SWAP_SWITCH, 1}, 		//bone 1 animation
						 {40,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE1,  ANI_SWAP_SWITCH, 2},
						 {80,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE1, ANI_SWAP_SWITCH, 3},
						 {120,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE1,  ANI_SWAP_SWITCH, 0},
						 {0,0,0, 0,0,0, 39, 2, 1, SM_OBJ_BONE2,  ANI_SWAP_SWITCH, 5}, 		//bone 2 animation
						 {40,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE2,  ANI_SWAP_SWITCH, 6},
						 {80,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE2, ANI_SWAP_SWITCH, 7},
						 {120,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE2,  ANI_SWAP_SWITCH, 4},
						 {0,0,0, 0,0,0, 39, 2, 1, SM_OBJ_BONE3,  ANI_SWAP_SWITCH, 9}, 		//bone 3 animation
						 {40,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE3,  ANI_SWAP_SWITCH, 10},
						 {80,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE3, ANI_SWAP_SWITCH, 11},
						 {120,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE3,  ANI_SWAP_SWITCH, 8},
						 {0,0,0, 0,0,0, 39, 2, 1, SM_OBJ_BONE4,  ANI_SWAP_SWITCH, 13}, 		//bone 4 animation
						 {40,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE4,  ANI_SWAP_SWITCH, 14},
						 {80,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE4, ANI_SWAP_SWITCH, 15},
						 {120,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE4,  ANI_SWAP_SWITCH, 12},
						 {0,0,0, 0,0,0, 39, 2, 1, SM_OBJ_BONE5,  ANI_SWAP_SWITCH, 17}, 		//bone 5 animation
						 {40,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE5,  ANI_SWAP_SWITCH, 18},
						 {80,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE5, ANI_SWAP_SWITCH, 19},
						 {120,0,0, 0,0,0, 0, 2, 0, SM_OBJ_BONE5,  ANI_SWAP_SWITCH, 16},
						 };

						 
void go_reset()
{
	u8 i=0;
	go_screenLoaded = 0;
	for(i=0; i<go_objectCount; i++)
	{
		go_objects[i].update = ANI_UPDATE_FULL;
		go_objects[i].active=1;
	}
	
	for(i=0; i<go_objectMoveCount; i++)
	{
		go_objectmove[i].active=1;
		if(i>0)
		{
			go_objectmove[i].delay=38;
		}
	}
	
	for(i=0; i<go_objectSwapCount; i++)
	{
		go_objectswap[i].active=0;
	}
	
	go_objectswap[0].active=1;
	go_objectswap[4].active=1;
	go_objectswap[8].active=1;
	go_objectswap[12].active=1;
	go_objectswap[16].active=1;
	
	go_objectswap[0].delay=39;
	go_objectswap[4].delay=39;
	go_objectswap[8].delay=39;
	go_objectswap[12].delay=39;
	go_objectswap[16].delay=39;
	
	main_pause = 1;
	vbDisplayHide();
}

void go_setUpScreen()
{
	if(go_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)GOSCREENCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)GOSCREENMAP, 8192);
		
		ani_objectCnt = go_objectCount;
		ani_objects = go_objects;
		
		ani_objectMoveCnt = go_objectMoveCount;
		ani_objectSwapCnt = go_objectSwapCount;
		ani_objectmove = go_objectmove;
		ani_objectswap = go_objectswap;
		ani_lastScreen = go_lastScreen;
		
		ani_drawObjects();
		
		WORLD_HEAD(31,WRLD_ON | WRLD_BGMAP | 13);
		WORLD_GSET(31,145,-17,170);
		WORLD_MSET(31,0,0,0);
		WORLD_SIZE(31,88,16);
		vbTextOutS(13, 0, 0, go_overText);
		
		main_pause = 0;
		vbDisplayShow();
		
		go_screenLoaded = 1;
		
	}

}