#include "../img/l1bgmap.h"
#include "../img/l1bgchar.h"
#include "../img/l1fishmap.h"
#include "../img/l1fishchar.h"
#include "../img/l1enemymap.h"
#include "../img/l1enemychar.h"

#define L1_OBJ_SAND1 0
#define L1_OBJ_SAND2 1
#define L1_OBJ_MNTF1 2
#define L1_OBJ_MNTF2 3
#define L1_OBJ_MNTN1 4
#define L1_OBJ_MNTN2 5
#define L1_OBJ_SCORE 6
#define L1_OBJ_PLAYER 7
#define L1_OBJ_VICTIM1 8
#define L1_OBJ_VICTIM2 9
#define L1_OBJ_VICTIM3 10
#define L1_OBJ_VICTIM4 11
#define L1_OBJ_ENEMY1 12
#define L1_OBJ_VICTIM5 13
#define L1_OBJ_VICTIM6 14
#define L1_OBJ_VICTIM7 15
#define L1_OBJ_VICTIM8 16
#define L1_OBJ_ENEMY2 17
#define L1_OBJ_ENEMY3 18
#define L1_OBJ_ENEMY_LF1 19
#define L1_OBJ_ENEMY_LF2 20
#define L1_OBJ_ENEMY_MI1 21
#define L1_OBJ_ENEMY_MI2 22
#define L1_OBJ_ENEMY_AL1 23
#define L1_OBJ_ENEMY_AL2 24
#define L1_OBJ_ENEMY_RM1 25
#define L1_OBJ_ENEMY_RM2 26
#define L1_OBJ_GOAL		 27

#define L1_SWAP_PLAYER_SWIM		0
#define L1_SWAP_PLAYER_EAT 		4
#define L1_SWAP_PLAYER_DEATH 	10
#define L1_SWAP_VICTIM1_SWIM  	14
#define L1_SWAP_VICTIM1_DEATH  	16
#define L1_SWAP_VICTIM2_SWIM  	20
#define L1_SWAP_VICTIM2_DEATH  	22
#define L1_SWAP_VICTIM3_SWIM  	26
#define L1_SWAP_VICTIM3_DEATH  	28
#define L1_SWAP_VICTIM4_SWIM  	32
#define L1_SWAP_VICTIM4_DEATH  	34
#define L1_SWAP_ENEMY1_SWIM  	38
#define L1_SWAP_ENEMY1_KILL  	42
#define L1_SWAP_VICTIM5_SWIM  	43
#define L1_SWAP_VICTIM5_DEATH  	45
#define L1_SWAP_VICTIM6_SWIM  	49
#define L1_SWAP_VICTIM6_DEATH  	51
#define L1_SWAP_VICTIM7_SWIM  	55
#define L1_SWAP_VICTIM7_DEATH  	57
#define L1_SWAP_VICTIM8_SWIM  	61
#define L1_SWAP_VICTIM8_DEATH  	63
#define L1_SWAP_ENEMY2_SWIM  	67
#define L1_SWAP_ENEMY2_KILL  	71
#define L1_SWAP_ENEMY3_SWIM  	72
#define L1_SWAP_ENEMY3_KILL  	76
#define L1_SWAP_ENEMY_LF1_SWIM  77
#define L1_SWAP_ENEMY_LF1_KILL  79
#define L1_SWAP_ENEMY_LF2_SWIM  80
#define L1_SWAP_ENEMY_LF2_KILL  82
#define L1_SWAP_ENEMY_MI1_SWIM  83
#define L1_SWAP_ENEMY_MI1_KILL  85
#define L1_SWAP_ENEMY_MI2_SWIM  90
#define L1_SWAP_ENEMY_MI2_KILL  92
#define L1_SWAP_ENEMY_AL1_SWIM  97
#define L1_SWAP_ENEMY_AL1_KILL  99
#define L1_SWAP_ENEMY_AL2_SWIM  100
#define L1_SWAP_ENEMY_AL2_KILL  102
#define L1_SWAP_ENEMY_RM1_SWIM  103
#define L1_SWAP_ENEMY_RM1_KILL  104
#define L1_SWAP_ENEMY_RM2_SWIM  109
#define L1_SWAP_ENEMY_RM2_KILL  110
#define L1_SWAP_GOAL_SWIM		115

#define L1_MOVE_PLAYER_DEATH  	6
#define L1_MOVE_VICTIM1_DEATH  	7
#define L1_MOVE_VICTIM2_DEATH  	8
#define L1_MOVE_VICTIM3_DEATH  	9
#define L1_MOVE_VICTIM4_DEATH  	10
#define L1_MOVE_VICTIM1_SWIM  	11
#define L1_MOVE_VICTIM2_SWIM  	12
#define L1_MOVE_VICTIM3_SWIM  	13
#define L1_MOVE_VICTIM4_SWIM  	14
#define L1_MOVE_ENEMY1_SWIM  	15
#define L1_MOVE_VICTIM5_DEATH  	16
#define L1_MOVE_VICTIM6_DEATH  	17
#define L1_MOVE_VICTIM7_DEATH  	18
#define L1_MOVE_VICTIM8_DEATH  	19
#define L1_MOVE_VICTIM5_SWIM  	20
#define L1_MOVE_VICTIM6_SWIM  	21
#define L1_MOVE_VICTIM7_SWIM  	22
#define L1_MOVE_VICTIM8_SWIM  	23
#define L1_MOVE_ENEMY2_SWIM  	24
#define L1_MOVE_ENEMY3_SWIM  	25
#define L1_MOVE_ENEMY_LF1_SWIM  26
#define L1_MOVE_ENEMY_LF2_SWIM  27
#define L1_MOVE_ENEMY_MI1_SWIM  28
#define L1_MOVE_ENEMY_MI2_SWIM  29
#define L1_MOVE_ENEMY_AL1_SWIM  30
#define L1_MOVE_ENEMY_AL2_SWIM  31
#define L1_MOVE_ENEMY_RM1_SWIM  32
#define L1_MOVE_ENEMY_RM2_SWIM  33
#define L1_MOVE_GOAL_SWIM  		34

u16 l1_screenLoaded = 0;

u16 l1_objectCount = 28;
u16 l1_objectSwapCount = 117;
u16 l1_objectMoveCount = 35;
s8 l1_lastScreen = 2;

object l1_objects[28] = {{ 0,0,0, 440,36, 0,2,188,   0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// SAND 1
						{  0,0,0, 440,36, 440,2,188, 0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// SAND 2
						{  0,0,58, 389,27, 0,6,167,  0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1}, 		// FAR MOUNTAIN 1
						{  0,0,58, 389,27, 389,6,167,  0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},   	// FAR MOUNTAIN 2
						{  0,0,36, 389,22, 0,5,171,  0, 29, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1}, 		// NEAR MOUNTAIN 1
						{  0,0,36, 389,22, 389,5,171,  0, 28, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},   	// NEAR MOUNTAIN 2
						{  0,0,120, 389,48, 0,0,0,  1, 5, ANI_UPDATE_FULL, ANI_TYPE_FIXED, 1},   		// SCORE
						{  0,0,0, 39,57, 100,0,100,  1, 16, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},   	// PLAYER
						{408,0,0, 40,30, 410,0,50,  1, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 1
						{408,0,0, 40,30, 410,0,85,  1, 24, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 2
						{408,0,0, 40,30, 410,0,120,  1, 23, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 3
						{408,0,0, 40,30, 410,0,155,  1, 22, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 4
						{0,0,0, 79,61, 410,0,100,  2, 21, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy shark 1
						{408,0,0, 40,30, 410,0,50,  1, 20, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 5
						{408,0,0, 40,30, 410,0,85,  1, 19, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 6
						{408,0,0, 40,30, 410,0,120,  1, 18, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 7
						{408,0,0, 40,30, 410,0,155,  1, 17, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 8
						{0,0,0, 79,61, 410,0,100,  2, 15, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy shark 2
						{0,0,0, 79,61, 410,0,100,  2, 14, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy shark 3
						{0,0,61, 56,48, 410,0,100,  2, 13, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy lightfish 1
						{0,0,61, 56,48, 410,0,100,  2, 12, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy lightfish 2
						{0,0,121, 40,33, 200,0,250,  2, 11, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy mine fish 1
						{0,0,121, 40,33, 200,0,250,  2, 10, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy mine fish 2
						{0,0,220, 104,26, 410,0,100,  2, 9, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy aal 1
						{0,0,220, 104,26, 410,0,100,  2, 8, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy aal 2
						{240,0,121, 39,100, 410,0,125,  2, 7, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy real mine 1
						{240,0,121, 39,100, 410,0,150,  2, 6, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy real mine 2
						{  0,0,240, 143,60, 410,-1,100,  3, 4, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},   		// GOAL
						};  	
						
movement l1_objectmove[35] = {{-437,2,188,3,1,1,0, ANI_MOVE_STRAIGHT,L1_OBJ_SAND1, 1, 440,2,188,1},
							 {-437,2,188,3,1,1,0, ANI_MOVE_STRAIGHT,L1_OBJ_SAND2, 1, 440,2,188,1},
							 {-388,6,167,1,1,1,0, ANI_MOVE_STRAIGHT,L1_OBJ_MNTF1, 1, 389,6,167,1},
							 {-388,6,167,1,1,1,0, ANI_MOVE_STRAIGHT,L1_OBJ_MNTF2, 1, 389,6,167,1},
							 {-386,5,171,3,1,1,0, ANI_MOVE_STRAIGHT,L1_OBJ_MNTN1, 1, 389,5,171,1},
							 {-386,5,171,3,1,1,0, ANI_MOVE_STRAIGHT,L1_OBJ_MNTN2, 1, 389,5,171,1},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_PLAYER,0, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM1,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM2,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM3,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM4,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM1,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM2,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM3,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM4,  2, 410,0,155,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY1,  2, 410,0,100,0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM5,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM6,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM7,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM8,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM5,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM6,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM7,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_VICTIM8,  2, 410,0,155,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY2,  2, 410,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY3,  2, 410,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_LF1, 2, 410,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_LF2, 2, 410,0,100,0},
							 {200,0,250,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_MI1, 2, 200,0,-50,0},
							 {200,0,250,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_MI2, 2, 200,0,-50,0},
							 {-110,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_AL1, 2, 410,0,100,0},
							 {-110,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_AL2, 2, 410,0,100,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_RM1, 2, 410,0,125,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_ENEMY_RM2, 2, 410,0,125,0},
							 {-110,0,125,1,1,1,0,ANI_MOVE_STRAIGHT,L1_OBJ_GOAL, 	 2, 410,0,125,0},
							};
							 
swap l1_objectswap[117] = {{40,0,0, 0,0,0, 10, 10, 1, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 1}, 		//player swim animation
						 {80,0,0, 0,0,0, 10, 10, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 2},
						 {120,0,0, 0,0,0, 10, 10, 0, L1_OBJ_PLAYER, ANI_SWAP_SWITCH, 3},
						 {0,0,0, 0,0,0, 10, 10, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {160,0,0, 0,0,0, 2, 2, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 5}, 		//player eat animation
						 {200,0,0, 0,0,0, 2, 2, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 6},
						 {240,0,0, 0,0,0, 2, 2, 0, L1_OBJ_PLAYER, ANI_SWAP_SWITCH, 7},
						 {280,0,0, 0,0,0, 2, 2, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 8},
						 {320,0,0, 0,0,0, 2, 2, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 9},
						 {360,0,0, 0,0,0, 2, 2, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 11}, 		//player death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 12},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_PLAYER, ANI_SWAP_SWITCH, 13},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_PLAYER,  ANI_SWAP_SWITCH, 10},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM1, ANI_SWAP_SWITCH, 15}, 		//victim 1 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM1, ANI_SWAP_SWITCH, 14},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 17}, 		//victim 1 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 18},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM1, ANI_SWAP_SWITCH, 19},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 16},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM2, ANI_SWAP_SWITCH, 21}, 		//victim 2 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM2, ANI_SWAP_SWITCH, 20},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 23}, 		//victim 2 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 24},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM2, ANI_SWAP_SWITCH, 25},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 22},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM3, ANI_SWAP_SWITCH, 27}, 		//victim 3 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM3, ANI_SWAP_SWITCH, 26},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 29}, 		//victim 3 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 30},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM3, ANI_SWAP_SWITCH, 31},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 28},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM4, ANI_SWAP_SWITCH, 33}, 		//victim 4 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM4, ANI_SWAP_SWITCH, 32},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 35}, 		//victim 4 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 36},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM4, ANI_SWAP_SWITCH, 37},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 34},
						 {80,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY1, ANI_SWAP_SWITCH, 39}, 		//enemy 1 swim animation 
						 {160,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY1, ANI_SWAP_SWITCH, 40}, 		
						 {80,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY1, ANI_SWAP_SWITCH, 41}, 		
						 {0,0,0, 0,0,0,  15, 15, 0, L1_OBJ_ENEMY1, ANI_SWAP_SWITCH, 38},
						 {240,0,0, 0,0,0, 0, 20, 0, L1_OBJ_ENEMY1, ANI_SWAP_SWITCH, 38},		//enemy 1 kill animation 		
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM5, ANI_SWAP_SWITCH, 44}, 		//victim 5 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM5, ANI_SWAP_SWITCH, 43},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 46}, 		//victim 5 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 47},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM5, ANI_SWAP_SWITCH, 48},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 45},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM6, ANI_SWAP_SWITCH, 50}, 		//victim 6 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM6, ANI_SWAP_SWITCH, 49},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 52}, 		//victim 6 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 53},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM6, ANI_SWAP_SWITCH, 54},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 51},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM7, ANI_SWAP_SWITCH, 56}, 		//victim 7 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM7, ANI_SWAP_SWITCH, 55},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 58}, 		//victim 7 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 59},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM7, ANI_SWAP_SWITCH, 60},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 57},
						 {448,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM8, ANI_SWAP_SWITCH, 62}, 		//victim 8 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L1_OBJ_VICTIM8, ANI_SWAP_SWITCH, 61},
						 {0,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 64}, 		//victim 8 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 65},
						 {80,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM8, ANI_SWAP_SWITCH, 66},
						 {120,0,58, 0,0,0, 5, 5, 0, L1_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 63},
						 {80,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY2, ANI_SWAP_SWITCH, 68}, 		//enemy 2 swim animation 
						 {160,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY2, ANI_SWAP_SWITCH, 69}, 		
						 {80,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY2, ANI_SWAP_SWITCH, 70}, 		
						 {0,0,0, 0,0,0,  15, 15, 0, L1_OBJ_ENEMY2, ANI_SWAP_SWITCH, 67},
						 {240,0,0, 0,0,0, 0, 20, 0, L1_OBJ_ENEMY2, ANI_SWAP_SWITCH, 67},		//enemy 2 kill animation 
						 {80,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY3, ANI_SWAP_SWITCH, 73}, 		//enemy 3 swim animation 
						 {160,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY3, ANI_SWAP_SWITCH, 74}, 		
						 {80,0,0, 0,0,0, 15, 15, 0, L1_OBJ_ENEMY3, ANI_SWAP_SWITCH, 75}, 		
						 {0,0,0, 0,0,0,  15, 15, 0, L1_OBJ_ENEMY3, ANI_SWAP_SWITCH, 72},
						 {240,0,0, 0,0,0, 0, 20, 0, L1_OBJ_ENEMY3, ANI_SWAP_SWITCH, 72},		//enemy 3 kill animation 
						 {0,0,61, 0,0,0, 20, 20, 0, L1_OBJ_ENEMY_LF1, ANI_SWAP_SWITCH, 78},		//enemy lf 1 swim animation 
						 {80,0,61, 0,0,0, 20, 20, 0, L1_OBJ_ENEMY_LF1, ANI_SWAP_SWITCH, 77},
						 {160,0,61, 0,0,0, 0, 40, 0, L1_OBJ_ENEMY_LF1, ANI_SWAP_SWITCH, 77},	//enemy lf 1 kill animation 
						 {0,0,61, 0,0,0, 20, 20, 0, L1_OBJ_ENEMY_LF2, ANI_SWAP_SWITCH, 81},		//enemy lf 2 swim animation 
						 {80,0,61, 0,0,0, 20, 20, 0, L1_OBJ_ENEMY_LF2, ANI_SWAP_SWITCH, 80},
						 {160,0,61, 0,0,0, 0, 40, 0, L1_OBJ_ENEMY_LF2, ANI_SWAP_SWITCH, 80},	//enemy lf 2 kill animation 
						 {0,0,121, 0,0,0,  0, 5, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 84},	//enemy mine 1 swim animation 
						 {40,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 83},  
						 {80,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 86},	//enemy mine 1 kill animation 
						 {120,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 87},	
						 {160,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 88},	
						 {200,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 89},
						 {300,0,121, 0,0,0, 0, 50, 0, L1_OBJ_ENEMY_MI1, ANI_SWAP_SWITCH, 89},						 
						 {0,0,121, 0,0,0,  0, 5, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 91},	//enemy mine 2 swim animation 
						 {40,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 90},  
						 {80,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 93},	//enemy mine 2 kill animation 
						 {120,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 94},	
						 {160,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 95},	
						 {200,0,121, 0,0,0, 0, 2, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 96},	
						 {300,0,121, 0,0,0, 0, 50, 0, L1_OBJ_ENEMY_MI2, ANI_SWAP_SWITCH, 96},	
						 {0,0,220, 0,0,0,  0, 20, 0, L1_OBJ_ENEMY_AL1, ANI_SWAP_SWITCH, 98},	//enemy aal 1 swim animation 
						 {0,0,260, 0,0,0, 0, 20, 0, L1_OBJ_ENEMY_AL1, ANI_SWAP_SWITCH, 97},  
						 {0,0,300, 0,0,0, 0, 30, 0, L1_OBJ_ENEMY_AL1, ANI_SWAP_SWITCH, 97},  	//enemy aal 1 kill animation 
						 {0,0,220, 0,0,0,  0, 20, 0, L1_OBJ_ENEMY_AL2, ANI_SWAP_SWITCH, 101},	//enemy aal 2 swim animation 
						 {0,0,260, 0,0,0, 0, 20, 0, L1_OBJ_ENEMY_AL2, ANI_SWAP_SWITCH, 100},  
						 {0,0,300, 0,0,0, 0, 30, 0, L1_OBJ_ENEMY_AL2, ANI_SWAP_SWITCH, 100},  	//enemy aal 2 kill animation 
						 {240,0,121, 0,0,0, 0, 30, 0, L1_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 103},  //enemy real mine 1 swim animation 
						 {80,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 105},		//enemy real mine 1 kill animation 
						 {120,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 106},	
						 {160,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 107},	
						 {200,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 108},
						 {300,0,121, 0,0,0, 0, 50, 0, L1_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 108},
						 {240,0,121, 0,0,0, 0, 30, 0, L1_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 109},  //enemy real mine 1 swim animation 
						 {80,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 111},		//enemy real mine 1 kill animation 
						 {120,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 112},	
						 {160,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 113},	
						 {200,0,121, 0,0,0, 0, 5, 0, L1_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 114},
						 {300,0,121, 0,0,0, 0, 50, 0, L1_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 114},
						 {144,0,240, 0,0,0, 0, 20, 0, L1_OBJ_GOAL, ANI_SWAP_SWITCH, 116},			//GOAL swim
						 {  0,0,240, 0,0,0, 0, 20, 0, L1_OBJ_GOAL, ANI_SWAP_SWITCH, 115},
						 };

void l1_reset()
{
	u16 i=0;
	l1_screenLoaded = 0;
	
	for(i=0; i<l1_objectCount; i++)
	{
		l1_objects[i].update = ANI_UPDATE_FULL;
		if(i>7)
		{
			l1_objects[i].active=0;
			l1_objects[i].x=410;
		}
	}
	
	for(i=0; i<l1_objectMoveCount; i++)
	{
		if(i>5)
		{
			l1_objectmove[i].active=0;
		}
	}
	
	for(i=0; i<l1_objectSwapCount; i++)
	{
		if(i>1)
		{
			l1_objectswap[i].active=0;
		}
	}
	
	main_pause = 1;
	vbDisplayHide();
}
						 
void l1_setUpScreen()
{
	if(l1_screenLoaded==0)
	{
		
		copymem((void*)CharSeg0, (void*)L1BGCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)L1BGMAP, 8192);
		
		copymem((void*)CharSeg1, (void*)L1FISHCHAR, 8192); 
		copymem((void*)BGMap(1), (void*)L1FISHMAP, 8192);
		
		copymem((void*)CharSeg2, (void*)L1ENEMYCHAR, 8192); 
		copymem((void*)BGMap(2), (void*)L1ENEMYMAP, 8192);
		
	
		ani_objectCnt = l1_objectCount;
		ani_objects = l1_objects;
		
		ani_objectMoveCnt = l1_objectMoveCount;
		ani_objectSwapCnt = l1_objectSwapCount;
		ani_objectmove = l1_objectmove;
		ani_objectswap = l1_objectswap;
		ani_lastScreen = l1_lastScreen;
		
		//this is game code and shouldn't be here (fix this!)
		ani_activateObject(L1_OBJ_PLAYER);
		ani_activateSwap(L1_SWAP_PLAYER_SWIM);
		ani_objectswap[L1_SWAP_PLAYER_SWIM].delay = 0;
		
		mp_playerStop();
		//mp_loadSong_inv3v12a();
		mp_loadSong_inv3v10g();
		mp_playerStart();
		
		ani_swapObjects();
		ani_moveObjects();	
		ani_drawObjects();
		
		main_pause = 0;
		vbDisplayShow();
		
		l1_screenLoaded = 1;
	}

}