#include "../img/l2bgmap.h"
#include "../img/l2bgchar.h"
#include "../img/l1fishmap.h"
#include "../img/l1fishchar.h"
#include "../img/l2enemymap.h"
#include "../img/l2enemychar.h"

#define L2_OBJ_MNTF1 0
#define L2_OBJ_MNTF2 1
#define L2_OBJ_WALL1 2
#define L2_OBJ_WALL2 3
#define L2_OBJ_PLAYER  4
#define L2_OBJ_SCORE 5
#define L2_OBJ_BLURP1 6
#define L2_OBJ_BLURP2 7
#define L2_OBJ_BLURP3 8
#define L2_OBJ_RIPVANFISH1 9
#define L2_OBJ_RIPVANFISH2 10
#define L2_OBJ_RIPVANFISH3 11
#define L2_OBJ_ENEMY_RO1 12
#define L2_OBJ_ENEMY_RO2 13
#define L2_OBJ_ENEMY_RO3 14
#define L2_OBJ_ENEMY_RO4 15
#define L2_OBJ_ENEMY_KILL1 16
#define L2_OBJ_ENEMY_KILL2 17
#define L2_OBJ_ENEMY_KILL3 18
#define L2_OBJ_ENEMY_KILL4 19
#define L2_OBJ_ENEMY_DEAD1 20
#define L2_OBJ_ENEMY_DEAD2 21
#define L2_OBJ_ENEMY_DO1 22
#define L2_OBJ_ENEMY_DO2 23
#define L2_OBJ_ENEMY_TUBE 24
#define L2_OBJ_ENEMY_BLOCK 25
#define L2_OBJ_ENEMY_MUSH 26
#define L2_OBJ_ENEMY_MUSIC 27
#define L2_OBJ_ENEMY_QUEST 28
#define L2_OBJ_ENEMY_COIN 29
#define L2_OBJ_ENEMY_GOAL 30



#define L2_SWAP_PLAYER_SWIM		0
#define L2_SWAP_PLAYER_EAT 		4
#define L2_SWAP_PLAYER_DEATH 	10
#define L2_SWAP_BLURP1_SWIM  	14
#define L2_SWAP_BLURP1_DEATH  	16
#define L2_SWAP_BLURP2_SWIM  	20
#define L2_SWAP_BLURP2_DEATH  	22
#define L2_SWAP_BLURP3_SWIM  	26
#define L2_SWAP_BLURP3_DEATH  	28
#define L2_SWAP_RIPVANFISH1_SWIM  	32
#define L2_SWAP_RIPVANFISH1_DEATH  	34
#define L2_SWAP_RIPVANFISH2_SWIM  	38
#define L2_SWAP_RIPVANFISH2_DEATH  	40
#define L2_SWAP_RIPVANFISH3_SWIM  	44
#define L2_SWAP_RIPVANFISH3_DEATH  	46
#define L2_SWAP_ENEMY_MUSIC_SWIM 50
#define L2_SWAP_ENEMY_QUEST_SWIM 54
#define L2_SWAP_ENEMY_COIN_SWIM 58
#define L2_SWAP_ENEMY_RO1_SWIM 	62
#define L2_SWAP_ENEMY_RO2_SWIM 	66
#define L2_SWAP_ENEMY_RO3_SWIM 	70
#define L2_SWAP_ENEMY_RO4_SWIM 	74
#define L2_SWAP_ENEMY_KILL1_SWIM 	78
#define L2_SWAP_ENEMY_KILL2_SWIM 	80
#define L2_SWAP_ENEMY_KILL3_SWIM 	82
#define L2_SWAP_ENEMY_KILL4_SWIM 	84
#define L2_SWAP_ENEMY_DEAD1_SWIM 	86
#define L2_SWAP_ENEMY_DEAD2_SWIM 	88
#define L2_SWAP_ENEMY_DO1_SWIM 		90
#define L2_SWAP_ENEMY_DO2_SWIM 		92
#define L2_SWAP_ENEMY_TUBE_SWIM 	94
#define L2_SWAP_ENEMY_MUSH_SWIM 	95
#define L2_SWAP_ENEMY_BLOCK_SWIM 	96
#define L2_SWAP_ENEMY_GOAL_SWIM 	97

#define L2_MOVE_PLAYER_DEATH  	4
#define L2_MOVE_BLURP1_DEATH  	5
#define L2_MOVE_BLURP2_DEATH  	6
#define L2_MOVE_BLURP3_DEATH  	7
#define L2_MOVE_RIPVANFISH1_DEATH  	8
#define L2_MOVE_BLURP1_SWIM  	9
#define L2_MOVE_BLURP2_SWIM  	10
#define L2_MOVE_BLURP3_SWIM  	11
#define L2_MOVE_RIPVANFISH1_SWIM  	12
#define L2_MOVE_RIPVANFISH2_DEATH  	13
#define L2_MOVE_RIPVANFISH3_DEATH  	14
#define L2_MOVE_RIPVANFISH2_SWIM  	15
#define L2_MOVE_RIPVANFISH3_SWIM  	16
#define L2_MOVE_ENEMY_RO1_SWIM  17
#define L2_MOVE_ENEMY_RO2_SWIM  18
#define L2_MOVE_ENEMY_RO3_SWIM  19
#define L2_MOVE_ENEMY_RO4_SWIM  20
#define L2_MOVE_ENEMY_KILL1_SWIM  21
#define L2_MOVE_ENEMY_KILL2_SWIM  22
#define L2_MOVE_ENEMY_KILL3_SWIM  23
#define L2_MOVE_ENEMY_KILL4_SWIM  24
#define L2_MOVE_ENEMY_DEAD1_SWIM  25
#define L2_MOVE_ENEMY_DEAD2_SWIM  26
#define L2_MOVE_ENEMY_DO1_SWIM  27
#define L2_MOVE_ENEMY_DO2_SWIM  28
#define L2_MOVE_ENEMY_TUBE_SWIM  29
#define L2_MOVE_ENEMY_BLOCK_SWIM  30
#define L2_MOVE_ENEMY_MUSH_SWIM  31
#define L2_MOVE_ENEMY_MUSIC_SWIM  32
#define L2_MOVE_ENEMY_QUEST_SWIM  33
#define L2_MOVE_ENEMY_COIN_SWIM  34
#define L2_MOVE_ENEMY_GOAL_SWIM  35


u16 l2_screenLoaded = 0;

u16 l2_objectCount = 31;
//u16 l2_objectSwapCount = 115;
u16 l2_objectSwapCount = 98;
//u16 l2_objectMoveCount = 34;
u16 l2_objectMoveCount = 36;
s8 l2_lastScreen = -1;

object l2_objects[31] = {
						{  0,0,36, 380,150, 0,6,50,  0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1}, 		// FAR MOUNTAIN 1
						{  0,0,36, 380,150, 380,6,50,  0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},   	// FAR MOUNTAIN 2
						{ 0,0,0, 432,36, 0,4,188,   0, 22, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// WALL 1
						{  0,0,0, 432,36, 432,4,188, 0, 21, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// WALL 2
						{  0,0,0, 39,57, 100,0,100,  1, 14, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},   	// PLAYER
						{  0,0,120, 389,48, 0,0,0,  1,  1, ANI_UPDATE_FULL, ANI_TYPE_FIXED, 1},   		// SCORE
						{0,0,0, 24,24, 410,0,100,  2, 20, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 1 (nf)
						{0,0,0, 24,24, 410,0,150,  2, 19, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 2 (nf)
						{0,0,0, 24,24, 410,0,150,  2, 18, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 3 (nf)
						{0,0,40, 24,24, 410,0,100,  2, 17, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // victim 4 (sf)
						{0,0,40, 24,24, 410,0,100,  2, 16, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // victim 5 (sf)
						{0,0,40, 24,24, 410,0,100,  2, 15, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},  // victim 6 (sf)
						{0,0,280, 48,32, 410,0,100,  2, 13, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy rocket fish 1
						{0,0,280, 48,32, 410,0,150,  2, 12, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy rocket fish 2
						{0,0,280, 48,32, 410,0,100,  2, 11, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy rocket fish 3
						{0,0,280, 48,32, 410,0,150,  2, 10, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy rocket fish 4
						{0,0,200, 32,32, 410,0,100,  2,  9, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy deadly fish 1
						{0,0,200, 32,32, 410,0,150,  2,  8, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy deadly fish 2
						{0,0,200, 32,32, 410,0,100,  2,  7, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy deadly fish 3
						{0,0,200, 32,32, 410,0,150,  2,  6, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy deadly fish 4
						{0,0,160, 24,16, 410,0,100,  2, 5, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 		// enemy dead fish 1
						{0,0,160, 24,16, 410,0,150,  2, 4, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 		// enemy dead fish 2
						{0,0,320, 40,16, 410,0,100,  2, 3, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 		// enemy dolphin 1
						{0,0,320, 40,16, 410,0,150,  2, 2, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 		// enemy dolphin 2
						{0,0,360,  32,29, 600,4,160,    2,29, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// tube 1
						{40,0,360, 16,16, 607,4,100,   2,28, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// block 1
						{60,0,360, 16,16, 750,4,172,   2,27, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// mushrom 1
						{140,0,360, 16,16, 500,4,130,  2,26, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// musicblock 1
						{140,0,384, 16,16, 450,4,100,  2,25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// question block 1
						{0,0,400, 15,16, 452,4,130,  2,24, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// coin 1
						{240,0,0,   48,145, 700,4,50,  2,23, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// goal 1
						};  	
						
movement l2_objectmove[36] = {{-428,4,188, 4,1,1,0, ANI_MOVE_STRAIGHT,L2_OBJ_WALL1, 1, 432,4,188,1},
							 {-428,4,188,  4,1,1,0, ANI_MOVE_STRAIGHT,L2_OBJ_WALL2, 1, 432,4,188,1},
							 {-376,6,50,   1,1,1,0, ANI_MOVE_STRAIGHT,L2_OBJ_MNTF1, 1, 380,6,50,1},
							 {-376,6,50,   1,1,1,0, ANI_MOVE_STRAIGHT,L2_OBJ_MNTF2, 1, 380,6,50,1},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_PLAYER,0, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_BLURP1,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_BLURP2,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_BLURP3,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_RIPVANFISH1,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_BLURP1,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_BLURP2,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_BLURP3,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_RIPVANFISH1,  2, 410,0,155,0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_RIPVANFISH2,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L2_OBJ_RIPVANFISH3,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_RIPVANFISH2,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_RIPVANFISH3,  2, 410,0,85,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_RO1,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_RO2,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_RO3,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_RO4,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_KILL1,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_KILL2,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_KILL3,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_KILL4,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_DEAD1,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_DEAD2,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_DO1,  2, 410,0,100,0},
							 {410,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_DO2,  2, 410,0,100,0},
							 {-80,4,160,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_TUBE,  2, 410,4,160,0},
							 {-80,4,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_BLOCK,  2, 410,4,100,0},
							 {-80,4,172,2,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_MUSH,  2, 410,4,172,0},
							 {-80,4,130,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_MUSIC,  2, 410,4,130,0},
							 {-80,4,100,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_QUEST,  2, 410,4,100,0},
							 {-80,4,130,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_COIN,  2, 410,4,130,0},
							 {-80,4,50,1,1,1,0,ANI_MOVE_STRAIGHT,L2_OBJ_ENEMY_GOAL,  2, 410,4,50,0},
							 
							 
							};
							 
swap l2_objectswap[98] = {{40,0,0, 0,0,0, 10, 10, 1, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 1}, 		//player swim animation
						 {80,0,0, 0,0,0, 10, 10, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 2},
						 {120,0,0, 0,0,0, 10, 10, 0, L2_OBJ_PLAYER, ANI_SWAP_SWITCH, 3},
						 {0,0,0, 0,0,0, 10, 10, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {160,0,0, 0,0,0, 2, 2, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 5}, 		//player eat animation
						 {200,0,0, 0,0,0, 2, 2, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 6},
						 {240,0,0, 0,0,0, 2, 2, 0, L2_OBJ_PLAYER, ANI_SWAP_SWITCH, 7},
						 {280,0,0, 0,0,0, 2, 2, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 8},
						 {320,0,0, 0,0,0, 2, 2, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 9},
						 {360,0,0, 0,0,0, 2, 2, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {0,0,58, 0,0,0, 5, 5, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 11}, 		//player death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 12},
						 {80,0,58, 0,0,0, 5, 5, 0, L2_OBJ_PLAYER, ANI_SWAP_SWITCH, 13},
						 {120,0,58, 0,0,0, 5, 5, 0, L2_OBJ_PLAYER,  ANI_SWAP_SWITCH, 10},
						 {40,0,0, 0,0,0,  0,20, 0, L2_OBJ_BLURP1, ANI_SWAP_SWITCH, 15}, 		//victim 1 swim animation 
						 {0,0,0, 0,0,0, 0,20, 0, L2_OBJ_BLURP1, ANI_SWAP_SWITCH, 14},
						 {0,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP1,  ANI_SWAP_SWITCH, 17}, 		//victim 1 death animation
						 {40,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP1,  ANI_SWAP_SWITCH, 18},
						 {80,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP1, ANI_SWAP_SWITCH, 19},
						 {120,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP1,  ANI_SWAP_SWITCH, 16},
						 {40,0,0, 0,0,0, 0, 20, 0, L2_OBJ_BLURP2, ANI_SWAP_SWITCH, 21}, 		//victim 2 swim animation 
						 {0,0,0, 0,0,0, 0, 20, 0, L2_OBJ_BLURP2, ANI_SWAP_SWITCH, 20},
						 {0,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP2,  ANI_SWAP_SWITCH, 23}, 		//victim 2 death animation
						 {40,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP2,  ANI_SWAP_SWITCH, 24},
						 {80,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP2, ANI_SWAP_SWITCH, 25},
						 {120,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP2,  ANI_SWAP_SWITCH, 22},
						 {40,0,0, 0,0,0, 0, 20, 0, L2_OBJ_BLURP3, ANI_SWAP_SWITCH, 27}, 		//victim 3 swim animation 
						 {0,0,0, 0,0,0, 0, 20, 0, L2_OBJ_BLURP3, ANI_SWAP_SWITCH, 26},
						 {0,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP3,  ANI_SWAP_SWITCH, 29}, 		//victim 3 death animation
						 {40,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP3,  ANI_SWAP_SWITCH, 30},
						 {80,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP3, ANI_SWAP_SWITCH, 31},
						 {120,0,80, 0,0,0, 5, 5, 0, L2_OBJ_BLURP3,  ANI_SWAP_SWITCH, 28},
						 {40,0,40, 0,0,0, 20, 20, 0, L2_OBJ_RIPVANFISH1, ANI_SWAP_SWITCH, 33}, 		//victim 4 swim animation 
						 {0,0,40, 0,0,0, 20, 20, 0, L2_OBJ_RIPVANFISH1, ANI_SWAP_SWITCH, 32},
						 {0,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH1,  ANI_SWAP_SWITCH, 35}, 		//victim 4 death animation
						 {40,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH1,  ANI_SWAP_SWITCH, 36},
						 {80,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH1, ANI_SWAP_SWITCH, 37},
						 {120,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH1,  ANI_SWAP_SWITCH, 34},
						 {40,0,40, 0,0,0, 20, 20, 0, L2_OBJ_RIPVANFISH2, ANI_SWAP_SWITCH, 39}, 		//victim 5 swim animation 
						 {0,0,40, 0,0,0, 20, 20, 0, L2_OBJ_RIPVANFISH2, ANI_SWAP_SWITCH, 38},
						 {0,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH2,  ANI_SWAP_SWITCH, 41}, 		//victim 5 death animation
						 {40,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH2,  ANI_SWAP_SWITCH, 42},
						 {80,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH2, ANI_SWAP_SWITCH, 43},
						 {120,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH2,  ANI_SWAP_SWITCH, 40},
						 {40,0,40, 0,0,0, 20, 20, 0, L2_OBJ_RIPVANFISH3, ANI_SWAP_SWITCH, 45}, 		//victim 6 swim animation 
						 {0,0,40, 0,0,0, 20, 20, 0, L2_OBJ_RIPVANFISH3, ANI_SWAP_SWITCH, 44},
						 {0,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH3,  ANI_SWAP_SWITCH, 47}, 		//victim 6 death animation
						 {40,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH3,  ANI_SWAP_SWITCH, 48},
						 {80,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH3, ANI_SWAP_SWITCH, 49},
						 {120,0,80, 0,0,0, 5, 5, 0, L2_OBJ_RIPVANFISH3,  ANI_SWAP_SWITCH, 46},
						 {157,0,360, 0,0,0, 0, 7, 0, L2_OBJ_ENEMY_MUSIC,  ANI_SWAP_SWITCH, 51}, 		//music block animation
						 {174,0,360, 0,0,0, 0, 7, 0, L2_OBJ_ENEMY_MUSIC,  ANI_SWAP_SWITCH, 52},
						 {191,0,360, 0,0,0, 0, 7, 0, L2_OBJ_ENEMY_MUSIC, ANI_SWAP_SWITCH, 53},
						 {140,0,360, 0,0,0, 0, 7, 0, L2_OBJ_ENEMY_MUSIC,  ANI_SWAP_SWITCH, 50},
						 {157,0,384, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_QUEST,  ANI_SWAP_SWITCH, 55}, 		//question block animation
						 {174,0,384, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_QUEST,  ANI_SWAP_SWITCH, 56},
						 {191,0,384, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_QUEST, ANI_SWAP_SWITCH, 57},
						 {140,0,384, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_QUEST,  ANI_SWAP_SWITCH, 54},
						 {16,0,400, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_COIN,  ANI_SWAP_SWITCH, 59}, 		//coin animation
						 {32,0,400, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_COIN,  ANI_SWAP_SWITCH, 60},
						 {48,0,400, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_COIN, ANI_SWAP_SWITCH, 61},
						 {0,0,400, 0,0,0, 0, 8, 0, L2_OBJ_ENEMY_COIN,  ANI_SWAP_SWITCH, 58},
						 {56,0,280, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH, 63}, 		//enemy rocket fish 1 animation 
						 {115,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH, 64},
						 {177,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH, 65},
						 {0,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO1, ANI_SWAP_SWITCH, 62},
						 {56,0,280, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_RO2, ANI_SWAP_SWITCH, 67}, 		//enemy rocket fish 2 animation 
						 {115,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO2, ANI_SWAP_SWITCH, 68},
						 {177,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO2, ANI_SWAP_SWITCH, 69},
						 {0,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO2, ANI_SWAP_SWITCH, 66},
						 {56,0,280, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_RO3, ANI_SWAP_SWITCH, 71}, 		//enemy rocket fish 3 animation 
						 {115,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO3, ANI_SWAP_SWITCH, 72},
						 {177,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO3, ANI_SWAP_SWITCH, 73},
						 {0,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO3, ANI_SWAP_SWITCH, 70},
						 {56,0,280, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_RO4, ANI_SWAP_SWITCH, 75}, 		//enemy rocket fish 4 animation 
						 {115,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO4, ANI_SWAP_SWITCH, 76},
						 {177,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO4, ANI_SWAP_SWITCH, 77},
						 {0,0,280, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_RO4, ANI_SWAP_SWITCH, 74},
						 {40,0,200, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_KILL1, ANI_SWAP_SWITCH, 79}, 		//enemy deadly fish 1 animation 
						 {0,0,200, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_KILL1, ANI_SWAP_SWITCH, 78},
						 {40,0,200, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_KILL2, ANI_SWAP_SWITCH, 81}, 		//enemy deadly fish 2 animation 
						 {0,0,200, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_KILL2, ANI_SWAP_SWITCH, 80},
						 {40,0,200, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_KILL3, ANI_SWAP_SWITCH, 83}, 		//enemy deadly fish 3 animation 
						 {0,0,200, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_KILL3, ANI_SWAP_SWITCH, 82},
						 {40,0,200, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_KILL4, ANI_SWAP_SWITCH, 85}, 		//enemy deadly fish 4 animation 
						 {0,0,200, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_KILL4, ANI_SWAP_SWITCH, 84},
						 {40,0,160, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_DEAD1, ANI_SWAP_SWITCH, 87}, 		//enemy dead fish 1 animation 
						 {0,0,160, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_DEAD1, ANI_SWAP_SWITCH, 86},
						 {40,0,160, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_DEAD2, ANI_SWAP_SWITCH, 89}, 		//enemy dead fish 2 animation 
						 {0,0,160, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_DEAD2, ANI_SWAP_SWITCH, 88},
						 {80,0,320, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_DO1, ANI_SWAP_SWITCH, 91}, 		//enemy dolphin fish 1 animation 
						 {0,0,320, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_DO1, ANI_SWAP_SWITCH, 90},
						 {80,0,320, 0,0,0, 0,10, 0, L2_OBJ_ENEMY_DO2, ANI_SWAP_SWITCH, 93}, 		//enemy dolphin fish 2 animation 
						 {0,0,320, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_DO2, ANI_SWAP_SWITCH, 92},
						 {0,0,360, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_TUBE, ANI_SWAP_SWITCH, 94},			// dummy for tube
						 {60,0,360, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_MUSH, ANI_SWAP_SWITCH, 95},			// dummy for mushroum
						 {40,0,360, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_BLOCK, ANI_SWAP_SWITCH, 96},			// dummy for block
						 {240,0,0, 0,0,0,  0,10, 0, L2_OBJ_ENEMY_GOAL, ANI_SWAP_SWITCH, 97},			// dummy for goal
						 };

void l2_reset()
{
	u16 i=0;
	l2_screenLoaded = 0;
	
	for(i=0; i<l2_objectCount; i++)
	{
		l2_objects[i].update = ANI_UPDATE_FULL;
		if(i>5)
		{
			l2_objects[i].active=0;
			l2_objects[i].x=410;
		}
	}
	
	for(i=0; i<l2_objectMoveCount; i++)
	{
		if(i>3)
		{
			l2_objectmove[i].active=0;
		}
	}
	
	for(i=0; i<l2_objectSwapCount; i++)
	{
		if(i>0)
		{
			l2_objectswap[i].active=0;
		}
	}
	
	main_pause = 1;
	vbDisplayHide();
}
						 
void l2_setUpScreen()
{
	if(l2_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)L2BGCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)L2BGMAP, 8192);
		
		copymem((void*)CharSeg1, (void*)L1FISHCHAR, 8192); 
		copymem((void*)BGMap(1), (void*)L1FISHMAP, 8192);
		
		copymem((void*)CharSeg2, (void*)L2ENEMYCHAR, 8192); 
		copymem((void*)BGMap(2), (void*)L2ENEMYMAP, 8192);
		
		mp_playerStop();
		mp_loadSong_underfx();
		mp_playerStart();
		
		
		ani_objectCnt = l2_objectCount;
		ani_objects = l2_objects;
		
		ani_objectMoveCnt = l2_objectMoveCount;
		ani_objectSwapCnt = l2_objectSwapCount;
		ani_objectmove = l2_objectmove;
		ani_objectswap = l2_objectswap;
		ani_lastScreen = l2_lastScreen;
		
		//this is game code and shouldn't be here (fix this!)
		ani_activateObject(L2_OBJ_PLAYER);
		ani_activateSwap(L2_SWAP_PLAYER_SWIM);
		ani_objectswap[L2_SWAP_PLAYER_SWIM].delay = 0;
		
		ani_swapObjects();
		ani_moveObjects();	
		ani_drawObjects();
		
		main_pause = 0;
		vbDisplayShow();
		
		l2_screenLoaded = 1;
	}

}