#include "../img/l3bgmap.h"
#include "../img/l3bgchar.h"
#include "../img/l1fishmap.h"
#include "../img/l1fishchar.h"
#include "../img/l3enemymap.h"
#include "../img/l3enemychar.h"

#define L3_OBJ_WATER1 0
#define L3_OBJ_WATER2 1
#define L3_OBJ_MNTF1 2
#define L3_OBJ_MNTF2 3
#define L3_OBJ_FENCE1 4
#define L3_OBJ_FENCE2 5
#define L3_OBJ_SCORE 6
#define L3_OBJ_PLAYER 7
#define L3_OBJ_VICTIM1 8
#define L3_OBJ_VICTIM2 9
#define L3_OBJ_VICTIM3 10
#define L3_OBJ_VICTIM4 11
#define L3_OBJ_VICTIM5 12
#define L3_OBJ_VICTIM6 13
#define L3_OBJ_VICTIM7 14
#define L3_OBJ_VICTIM8 15
#define L3_OBJ_BIGMAK  16
#define L3_OBJ_PLAIN1  17
#define L3_OBJ_PLAIN2  18
#define L3_OBJ_PLAIN3  19
#define L3_OBJ_WALRUS1  20
#define L3_OBJ_WALRUS2  21
#define L3_OBJ_WALRUS3  22
#define L3_OBJ_FLASH1  23
#define L3_OBJ_FLASH2  24
#define L3_OBJ_ENEMY_RM1 25
#define L3_OBJ_ENEMY_RM2 26
#define L3_OBJ_GOAL 	 27

#define L3_SWAP_PLAYER_SWIM		0
#define L3_SWAP_PLAYER_EAT 		4
#define L3_SWAP_PLAYER_DEATH 	10
#define L3_SWAP_VICTIM1_SWIM  	14
#define L3_SWAP_VICTIM1_DEATH  	16
#define L3_SWAP_VICTIM2_SWIM  	20
#define L3_SWAP_VICTIM2_DEATH  	22
#define L3_SWAP_VICTIM3_SWIM  	26
#define L3_SWAP_VICTIM3_DEATH  	28
#define L3_SWAP_VICTIM4_SWIM  	32
#define L3_SWAP_VICTIM4_DEATH  	34
#define L3_SWAP_VICTIM5_SWIM  	38
#define L3_SWAP_VICTIM5_DEATH  	40
#define L3_SWAP_VICTIM6_SWIM  	44
#define L3_SWAP_VICTIM6_DEATH  	46
#define L3_SWAP_VICTIM7_SWIM  	50
#define L3_SWAP_VICTIM7_DEATH  	52
#define L3_SWAP_VICTIM8_SWIM  	56
#define L3_SWAP_VICTIM8_DEATH  	59
#define L3_SWAP_BIGMAK_SWIM  	66
#define L3_SWAP_BIGMAK_KILL  	70
#define L3_SWAP_PLAIN1_SWIM  	72
#define L3_SWAP_PLAIN1_KILL  	76
#define L3_SWAP_PLAIN2_SWIM  	79
#define L3_SWAP_PLAIN2_KILL  	83
#define L3_SWAP_PLAIN3_SWIM  	86
#define L3_SWAP_PLAIN3_KILL  	90
#define L3_SWAP_WALRUS1_SWIM  	93
#define L3_SWAP_WALRUS1_KILL  	97
#define L3_SWAP_WALRUS2_SWIM  	98
#define L3_SWAP_WALRUS2_KILL  	102
#define L3_SWAP_WALRUS3_SWIM  	103
#define L3_SWAP_WALRUS3_KILL  	107
#define L3_SWAP_FLASH1_SWIM	   108
#define L3_SWAP_FLASH1_KILL	   110
#define L3_SWAP_FLASH2_SWIM	   111
#define L3_SWAP_FLASH2_KILL	   113
#define L3_SWAP_ENEMY_RM1_SWIM  	114
#define L3_SWAP_ENEMY_RM1_KILL  	115
#define L3_SWAP_ENEMY_RM2_SWIM  	120
#define L3_SWAP_ENEMY_RM2_KILL  	121
#define L3_SWAP_GOAL_SWIM  			126

#define L3_MOVE_PLAYER_DEATH  	6
#define L3_MOVE_VICTIM1_DEATH  	7
#define L3_MOVE_VICTIM2_DEATH  	8
#define L3_MOVE_VICTIM3_DEATH  	9
#define L3_MOVE_VICTIM4_DEATH  	10
#define L3_MOVE_VICTIM1_SWIM  	11
#define L3_MOVE_VICTIM2_SWIM  	12
#define L3_MOVE_VICTIM3_SWIM  	13
#define L3_MOVE_VICTIM4_SWIM  	14
#define L3_MOVE_VICTIM5_DEATH  	15
#define L3_MOVE_VICTIM6_DEATH  	16
#define L3_MOVE_VICTIM7_DEATH  	17
#define L3_MOVE_VICTIM8_DEATH  	18
#define L3_MOVE_VICTIM5_SWIM  	19
#define L3_MOVE_VICTIM6_SWIM  	20
#define L3_MOVE_VICTIM7_SWIM  	21
#define L3_MOVE_VICTIM8_SWIM  	22
#define L3_MOVE_BIGMAK_SWIM  	23
#define L3_MOVE_PLAIN1_SWIM  	24
#define L3_MOVE_PLAIN2_SWIM  	25
#define L3_MOVE_PLAIN3_SWIM  	26
#define L3_MOVE_WALRUS1_SWIM  	27
#define L3_MOVE_WALRUS2_SWIM  	28
#define L3_MOVE_WALRUS3_SWIM  	29
#define L3_MOVE_FLASH1_SWIM  	30
#define L3_MOVE_FLASH2_SWIM  	31
#define L3_MOVE_ENEMY_RM1_SWIM 	32
#define L3_MOVE_ENEMY_RM2_SWIM 	33
#define L3_MOVE_GOAL_SWIM 		34


u16 l3_screenLoaded = 0;

u16 l3_objectCount = 28;
u16 l3_objectSwapCount = 128;
u16 l3_objectMoveCount = 35;
s8 l3_lastScreen = 2;

object l3_objects[28] = {{ 0,0,0, 400,23, 0,1,201,     0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// WATER 1
						{  0,0,0, 400,23, 400,1,201,   0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// WATER 2
						{  0,0,120, 425,44, 0,6,90,    0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, 	// FAR MOUNTAIN 1
						{  0,0,120, 425,44, 425,6,90,  0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},   // FAR MOUNTAIN 2
						{  0,0,31,  447,80, 0,4,125,   0, 29,  ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1}, 	// FENCE 1
						{  0,0,31,  447,80, 447,4,125, 0, 28,  ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},   	// FENCE 2
						{  0,0,120, 389,48, 0,0,0,     1, 5,  ANI_UPDATE_FULL, ANI_TYPE_FIXED, 1},   	// SCORE
						{  0,0,0, 39,57, 100,0,100,    1, 17, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},   // PLAYER
						{408,0,0, 40,30, 410,0,50,     1, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 1
						{408,0,0, 40,30, 410,0,85,     1, 24, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 2
						{408,0,0, 40,30, 410,0,120,    1, 23, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 3
						{408,0,0, 40,30, 410,0,155,    1, 22, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 4
						{408,0,0, 40,30, 410,0,50,     1, 21, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 5
						{408,0,0, 40,30, 410,0,85,     1, 20, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 6
						{408,0,0, 40,30, 410,0,120,    1, 19, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 7
						{408,0,0, 40,30, 410,0,155,    1, 18, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 8
						{0,0,0, 140,200, -150,0,30,    2, 6, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},   // enemy big mak
						{0,0,40, 45,45, 410,0,100,     3, 15, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy plain fish 1
						{0,0,40, 45,45, 410,0,100,     3, 14, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy plain fish 2
						{0,0,40, 45,45, 410,0,100,     3, 13, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy plain fish 3
						{0,0,280, 44,65, 410,0,100,    0, 12, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy walross 1
						{0,0,280, 44,65, 410,0,250,    0, 11, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy walross 2
						{0,0,280, 44,65, 410,0,250,    0, 10, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy walross 3
						{0,0,360,  60,45, 410,0,100,    0,  9, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy flash fish 1
						{0,0,360,  60,45, 410,0,100,    0,  8, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy flash fish 2
						{240,0,121, 39,100, 410,0,125,  3,  7,  ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy real mine 1
						{240,0,121, 39,100, 410,0,150,  3,  16,  ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy real mine 2
						{  0,0,240, 143,60, 410,-1,100,  3, 4, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},   		// GOAL
						};  	
						
movement l3_objectmove[35] = {{-396,1,201, 4,1,1,0, ANI_MOVE_STRAIGHT,L3_OBJ_WATER1, 1, 400,1,201,1},
							 {-396, 1,201, 4,1,1,0, ANI_MOVE_STRAIGHT,L3_OBJ_WATER2, 1, 400,1,201,1},
							 {-424,6,90,   1,1,1,0, ANI_MOVE_STRAIGHT,L3_OBJ_MNTF1, 1, 425,6,90,1},
							 {-424,6,90,   1,1,1,0, ANI_MOVE_STRAIGHT,L3_OBJ_MNTF2, 1, 425,6,90,1},
							 {-445,4,125,  3,1,1,0, ANI_MOVE_STRAIGHT,L3_OBJ_FENCE1, 1, 447,4,125,1},
							 {-445,4,125,  3,1,1,0, ANI_MOVE_STRAIGHT,L3_OBJ_FENCE2, 1, 447,4,125,1},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_PLAYER,0, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM1,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM2,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM3,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM4,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM1,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM2,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM3,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM4,  2, 410,0,155,0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM5,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM6,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM7,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM8,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM5,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM6,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM7,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_VICTIM8,  2, 410,0,155,0},
							 {0,0,30,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_BIGMAK,      3, -150,0,30,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_PLAIN1,   2, 410,0,155,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_PLAIN2,   2, 410,0,155,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_PLAIN3,   2, 410,0,155,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_WALRUS1,  2, 410,0,155,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_WALRUS2,  2, 410,0,155,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_WALRUS3,  2, 410,0,155,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_FLASH1,   2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_FLASH2,   2, 200,0,100,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_ENEMY_RM1, 2, 410,0,125,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_ENEMY_RM2, 2, 410,0,125,0},
							 {-110,0,125,1,1,1,0,ANI_MOVE_STRAIGHT,L3_OBJ_GOAL, 	 2, 410,0,125,0},
							};
							 
swap l3_objectswap[128] = {{40,0,0, 0,0,0, 10, 10, 1, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 1}, 		//player swim animation
						 {80,0,0, 0,0,0, 10, 10, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 2},
						 {120,0,0, 0,0,0, 10, 10, 0, L3_OBJ_PLAYER, ANI_SWAP_SWITCH, 3},
						 {0,0,0, 0,0,0, 10, 10, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {160,0,0, 0,0,0, 2, 2, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 5}, 		//player eat animation
						 {200,0,0, 0,0,0, 2, 2, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 6},
						 {240,0,0, 0,0,0, 2, 2, 0, L3_OBJ_PLAYER, ANI_SWAP_SWITCH, 7},
						 {280,0,0, 0,0,0, 2, 2, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 8},
						 {320,0,0, 0,0,0, 2, 2, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 9},
						 {360,0,0, 0,0,0, 2, 2, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 11}, 		//player death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 12},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_PLAYER, ANI_SWAP_SWITCH, 13},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_PLAYER,  ANI_SWAP_SWITCH, 10},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM1, ANI_SWAP_SWITCH, 15}, 		//victim 1 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM1, ANI_SWAP_SWITCH, 14},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 17}, 		//victim 1 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 18},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM1, ANI_SWAP_SWITCH, 19},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 16},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM2, ANI_SWAP_SWITCH, 21}, 		//victim 2 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM2, ANI_SWAP_SWITCH, 20},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 23}, 		//victim 2 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 24},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM2, ANI_SWAP_SWITCH, 25},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 22},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM3, ANI_SWAP_SWITCH, 27}, 		//victim 3 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM3, ANI_SWAP_SWITCH, 26},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 29}, 		//victim 3 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 30},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM3, ANI_SWAP_SWITCH, 31},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 28},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM4, ANI_SWAP_SWITCH, 33}, 		//victim 4 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM4, ANI_SWAP_SWITCH, 32},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 35}, 		//victim 4 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 36},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM4, ANI_SWAP_SWITCH, 37},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 34},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM5, ANI_SWAP_SWITCH, 39}, 		//victim 5 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM5, ANI_SWAP_SWITCH, 38},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 41}, 		//victim 5 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 42},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM5, ANI_SWAP_SWITCH, 43},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 40},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM6, ANI_SWAP_SWITCH, 45}, 		//victim 6 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM6, ANI_SWAP_SWITCH, 44},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 47}, 		//victim 6 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 48},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM6, ANI_SWAP_SWITCH, 49},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 46},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM7, ANI_SWAP_SWITCH, 51}, 		//victim 7 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM7, ANI_SWAP_SWITCH, 50},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 53}, 		//victim 7 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 54},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM7, ANI_SWAP_SWITCH, 55},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 52},
						 {448,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM8, ANI_SWAP_SWITCH, 57}, 		//victim 8 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L3_OBJ_VICTIM8, ANI_SWAP_SWITCH, 56},
						 {0,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 59}, 		//victim 8 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 60},
						 {80,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM8, ANI_SWAP_SWITCH, 61},
						 {120,0,58, 0,0,0, 5, 5, 0, L3_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 58},
						 {0,0,200, 0,0,0, 0, 30, 1, L3_OBJ_MNTF1, ANI_SWAP_SWITCH, 63},			//mountain animation 1
						 {0,0,120, 0,0,0, 0, 30, 0, L3_OBJ_MNTF1, ANI_SWAP_SWITCH, 62},
						 {0,0,200, 0,0,0, 0, 30, 1, L3_OBJ_MNTF2, ANI_SWAP_SWITCH, 65},			//mountain animation 2
						 {0,0,120, 0,0,0, 0, 30, 0, L3_OBJ_MNTF2, ANI_SWAP_SWITCH, 64},
						 {160,0,0, 0,0,0, 0, 10, 0, L3_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 67}, 		//big mak swim animation
						 {320,0,0, 0,0,0, 0, 10, 0, L3_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 68},
						 {160,0,0, 0,0,0, 0, 10, 0, L3_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 69},
						 {0,0,0,   0,0,0, 0, 100, 0, L3_OBJ_BIGMAK, ANI_SWAP_SWITCH, 66}, 
						 {0,0,200, 0,0,0, 0, 7, 0, L3_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 71}, 		//big mak kill animation
						 {320,0,200, 0,0,0, 0, 7, 0, L3_OBJ_BIGMAK,  ANI_SWAP_SWITCH, 66},
						 {48,0,40,   0,0,0, 0, 10, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 73}, 		//plain fish 1 swim
						 {96,0,40,   0,0,0, 0, 10, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 74}, 		
						 {144,0,40,  0,0,0, 0, 10, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 75}, 		
						 {0,0,40,    0,0,0, 0, 10, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 72}, 		
						 {192,0,40,   0,0,0,  0, 5, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 77}, 		//plain fish 1 kill
						 {240,0,40,  0,0,0,   0, 10, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 78}, 		
						 {288,0,40,    0,0,0, 0, 30, 0, L3_OBJ_PLAIN1, ANI_SWAP_SWITCH, 72}, 		
						 {48,0,40,   0,0,0, 0, 10, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 80}, 		//plain fish 2 swim
						 {96,0,40,   0,0,0, 0, 10, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 81}, 		
						 {144,0,40,  0,0,0, 0, 10, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 82}, 		
						 {0,0,40,    0,0,0, 0, 10, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 79}, 		
						 {192,0,40,   0,0,0,  0, 5, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 84}, 		//plain fish 2 kill
						 {240,0,40,  0,0,0,   0, 10, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 85}, 		
						 {288,0,40,    0,0,0, 0, 30, 0, L3_OBJ_PLAIN2, ANI_SWAP_SWITCH, 79}, 		
						 {48,0,40,   0,0,0, 0, 10, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 87}, 		//plain fish 3 swim
						 {96,0,40,   0,0,0, 0, 10, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 88}, 		
						 {144,0,40,  0,0,0, 0, 10, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 89}, 		
						 {0,0,40,    0,0,0, 0, 10, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 86}, 		
						 {192,0,40,   0,0,0,  0, 5, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 91}, 		//plain fish 3 kill
						 {240,0,40,  0,0,0,   0, 10, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 92}, 		
						 {288,0,40,    0,0,0, 0, 30, 0, L3_OBJ_PLAIN3, ANI_SWAP_SWITCH, 86}, 		
						 {48,0,280,   0,0,0,  0, 10,  0, L3_OBJ_WALRUS1, ANI_SWAP_SWITCH, 94}, 		//walrus 1 swim
						 {96,0,280,  0,0,0,   0, 10, 0, L3_OBJ_WALRUS1, ANI_SWAP_SWITCH, 95}, 		
						 {48,0,280,   0,0,0,  0, 10,  0, L3_OBJ_WALRUS1, ANI_SWAP_SWITCH, 96}, 		
						 {0,0,280,    0,0,0,  0, 10,  0, L3_OBJ_WALRUS1, ANI_SWAP_SWITCH, 93}, 		
						 {144,0,280,   0,0,0,  0, 30,  0, L3_OBJ_WALRUS1, ANI_SWAP_SWITCH, 93}, 		//walrus 1 kill
						 {48,0,280,   0,0,0,  0, 10,  0, L3_OBJ_WALRUS2, ANI_SWAP_SWITCH, 99}, 		//walrus 2 swim
						 {96,0,280,  0,0,0,   0, 10, 0, L3_OBJ_WALRUS2, ANI_SWAP_SWITCH, 100}, 		
						 {48,0,280,   0,0,0,  0, 10,  0, L3_OBJ_WALRUS2, ANI_SWAP_SWITCH, 101}, 		
						 {0,0,280,    0,0,0,  0, 10,  0, L3_OBJ_WALRUS2, ANI_SWAP_SWITCH, 98}, 		
						 {144,0,280,   0,0,0,  0, 30,  0, L3_OBJ_WALRUS2, ANI_SWAP_SWITCH, 98}, 		//walrus 2 swim
						 {48,0,280,   0,0,0,  0, 10,  0, L3_OBJ_WALRUS3, ANI_SWAP_SWITCH, 104}, 		//walrus 3 swim
						 {96,0,280,  0,0,0,   0, 10, 0, L3_OBJ_WALRUS3, ANI_SWAP_SWITCH, 105}, 		
						 {48,0,280,   0,0,0,  0, 10,  0, L3_OBJ_WALRUS3, ANI_SWAP_SWITCH, 106}, 		
						 {0,0,280,    0,0,0,  0, 10,  0, L3_OBJ_WALRUS3, ANI_SWAP_SWITCH, 103}, 		
						 {144,0,280,   0,0,0,  0, 30,  0, L3_OBJ_WALRUS3, ANI_SWAP_SWITCH, 103}, 		//walrus 3 swim
						 {80,0,360,   0,0,0, 0, 10, 1, L3_OBJ_FLASH1, ANI_SWAP_SWITCH, 109},  		//enemy flash 1 swim
						 {0,0,360,    0,0,0, 0, 10, 0, L3_OBJ_FLASH1, ANI_SWAP_SWITCH, 108},
						 {240,0,360,    0,0,0, 0, 40, 0, L3_OBJ_FLASH1, ANI_SWAP_SWITCH, 108},  	//enemy flash 1 kill
						 {80,0,360,   0,0,0, 0, 10, 0, L3_OBJ_FLASH2, ANI_SWAP_SWITCH, 112},  		//enemy flash 2 swim
						 {0,0,360,    0,0,0, 0, 10, 0, L3_OBJ_FLASH2, ANI_SWAP_SWITCH, 111},
						 {240,0,360,    0,0,0, 0, 40, 0, L3_OBJ_FLASH2, ANI_SWAP_SWITCH, 111},  	//enemy flash 2 kill
						 {240,0,121, 0,0,0, 0, 30, 0, L3_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 114},  //enemy real mine 1 swim animation 
						 {80,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 116},	//enemy real mine 1 kill animation 
						 {120,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 117},	
						 {160,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 118},	
						 {200,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 119},
						 {300,0,121, 0,0,0, 0, 50, 0, L3_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 119},
						 {240,0,121, 0,0,0, 0, 30, 0, L3_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 120},  //enemy real mine 2 swim animation 
						 {80,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 122},	//enemy real mine 2 kill animation 
						 {120,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 123},	
						 {160,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 124},	
						 {200,0,121, 0,0,0, 0, 5, 0, L3_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 125},
						 {300,0,121, 0,0,0, 0, 50, 0, L3_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 125},
						 {144,0,240, 0,0,0, 0, 20, 0, L1_OBJ_GOAL, ANI_SWAP_SWITCH, 127},			//GOAL swim
						 {  0,0,240, 0,0,0, 0, 20, 0, L1_OBJ_GOAL, ANI_SWAP_SWITCH, 126},
						 };

void l3_reset()
{
	u16 i=0;
	l3_screenLoaded = 0;
	
	for(i=0; i<l3_objectCount; i++)
	{
		l3_objects[i].update = ANI_UPDATE_FULL;
		if(i>7)
		{
			l3_objects[i].active=0;
			l3_objects[i].x=410;
		}
	}
	
	for(i=0; i<l3_objectMoveCount; i++)
	{
		if(i>5)
		{
			l3_objectmove[i].active=0;
		}
	}
	
	for(i=0; i<l3_objectSwapCount; i++)
	{
		if(i>1)
		{
			l3_objectswap[i].active=0;
		}
	}
	l3_objectswap[62].active=1;
	l3_objectswap[64].active=1;
	
	main_pause = 1;
	vbDisplayHide();
}
						 
void l3_setUpScreen()
{
	if(l3_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)L3BGCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)L3BGMAP, 8192);
		
		copymem((void*)CharSeg1, (void*)L1FISHCHAR, 8192); 
		copymem((void*)BGMap(1), (void*)L1FISHMAP, 8192);
		
		copymem((void*)CharSeg2, (void*)L3ENEMYCHAR, 8192); 
		copymem((void*)BGMap(2), (void*)L3ENEMYMAP, 8192);
		
		ani_objectCnt = l3_objectCount;
		ani_objects = l3_objects;
		
		ani_objectMoveCnt = l3_objectMoveCount;
		ani_objectSwapCnt = l3_objectSwapCount;
		ani_objectmove = l3_objectmove;
		ani_objectswap = l3_objectswap;
		ani_lastScreen = l3_lastScreen;
		
		//this is game code and shouldn't be here (fix this!)
		ani_activateObject(L3_OBJ_PLAYER);
		ani_activateSwap(L3_SWAP_PLAYER_SWIM);
		ani_objectswap[L3_SWAP_PLAYER_SWIM].delay = 0;

		mp_playerStop();
		mp_loadSong_inv3v15h();
		mp_playerStart();
		
		ani_swapObjects();
		ani_moveObjects();	
		ani_drawObjects();
		
		main_pause = 0;
		vbDisplayShow();
		
		l3_screenLoaded = 1;
	}

}