#include "../img/l4bgmap.h"
#include "../img/l4bgchar.h"
#include "../img/l1fishmap.h"
#include "../img/l1fishchar.h"
#include "../img/l4enemymap.h"
#include "../img/l4enemychar.h"

#define L4_OBJ_ROCKB1 0
#define L4_OBJ_ROCKB2 1
#define L4_OBJ_WALL1 2
#define L4_OBJ_WALL2 3
#define L4_OBJ_ROCKT1 4
#define L4_OBJ_ROCKT2 5
#define L4_OBJ_SCORE 6
#define L4_OBJ_PLAYER 7
#define L4_OBJ_VICTIM1 8
#define L4_OBJ_VICTIM2 9
#define L4_OBJ_VICTIM3 10
#define L4_OBJ_VICTIM4 11
#define L4_OBJ_VICTIM5 12
#define L4_OBJ_VICTIM6 13
#define L4_OBJ_VICTIM7 14
#define L4_OBJ_VICTIM8 15
#define L4_OBJ_ENEMY_TOOTH1 16
#define L4_OBJ_ENEMY_TOOTH2 17
#define L4_OBJ_ENEMY_TOOTH3 18
#define L4_OBJ_ENEMY_SWARM1 19
#define L4_OBJ_ENEMY_SWARM2 20
#define L4_OBJ_FLASH1 21
#define L4_OBJ_FLASH2 22
#define L4_OBJ_ENEMY_STAR1 23
#define L4_OBJ_ENEMY_STAR2 24
#define L4_OBJ_ENEMY_RM1 25
#define L4_OBJ_ENEMY_RM2 26
#define L4_OBJ_GOAL 	 27

#define L4_SWAP_PLAYER_SWIM		0
#define L4_SWAP_PLAYER_EAT 		4
#define L4_SWAP_PLAYER_DEATH 	10
#define L4_SWAP_VICTIM1_SWIM  	14
#define L4_SWAP_VICTIM1_DEATH  	16
#define L4_SWAP_VICTIM2_SWIM  	20
#define L4_SWAP_VICTIM2_DEATH  	22
#define L4_SWAP_VICTIM3_SWIM  	26
#define L4_SWAP_VICTIM3_DEATH  	28
#define L4_SWAP_VICTIM4_SWIM  	32
#define L4_SWAP_VICTIM4_DEATH  	34
#define L4_SWAP_VICTIM5_SWIM  	38
#define L4_SWAP_VICTIM5_DEATH  	40
#define L4_SWAP_VICTIM6_SWIM  	44
#define L4_SWAP_VICTIM6_DEATH  	46
#define L4_SWAP_VICTIM7_SWIM  	50
#define L4_SWAP_VICTIM7_DEATH  	52
#define L4_SWAP_VICTIM8_SWIM  	56
#define L4_SWAP_VICTIM8_DEATH  	59
#define L4_SWAP_ENEMY_TOOTH1_SWIM	62
#define L4_SWAP_ENEMY_TOOTH1_KILL	65
#define L4_SWAP_ENEMY_TOOTH2_SWIM	67
#define L4_SWAP_ENEMY_TOOTH2_KILL	70
#define L4_SWAP_ENEMY_TOOTH3_SWIM	72
#define L4_SWAP_ENEMY_TOOTH3_KILL	75
#define L4_SWAP_ENEMY_SWARM1_SWIM	77
#define L4_SWAP_ENEMY_SWARM1_KILL	79
#define L4_SWAP_ENEMY_SWARM2_SWIM	83
#define L4_SWAP_ENEMY_SWARM2_KILL	85
#define L4_SWAP_FLASH1_SWIM	89
#define L4_SWAP_FLASH1_KILL	91
#define L4_SWAP_FLASH2_SWIM	92
#define L4_SWAP_FLASH2_KILL	94
#define L4_SWAP_ENEMY_STAR1_SWIM	95
#define L4_SWAP_ENEMY_STAR1_KILL	97
#define L4_SWAP_ENEMY_STAR2_SWIM	99
#define L4_SWAP_ENEMY_STAR2_KILL	101
#define L4_SWAP_ENEMY_RM1_SWIM  	103
#define L4_SWAP_ENEMY_RM1_KILL  	104
#define L4_SWAP_ENEMY_RM2_SWIM  	109
#define L4_SWAP_ENEMY_RM2_KILL  	110
#define L4_SWAP_GOAL_SWIM  			115


#define L4_MOVE_PLAYER_DEATH  	6
#define L4_MOVE_VICTIM1_DEATH  	7
#define L4_MOVE_VICTIM2_DEATH  	8
#define L4_MOVE_VICTIM3_DEATH  	9
#define L4_MOVE_VICTIM4_DEATH  	10
#define L4_MOVE_VICTIM1_SWIM  	11
#define L4_MOVE_VICTIM2_SWIM  	12
#define L4_MOVE_VICTIM3_SWIM  	13
#define L4_MOVE_VICTIM4_SWIM  	14
#define L4_MOVE_VICTIM5_DEATH  	15
#define L4_MOVE_VICTIM6_DEATH  	16
#define L4_MOVE_VICTIM7_DEATH  	17
#define L4_MOVE_VICTIM8_DEATH  	18
#define L4_MOVE_VICTIM5_SWIM  	19
#define L4_MOVE_VICTIM6_SWIM  	20
#define L4_MOVE_VICTIM7_SWIM  	21
#define L4_MOVE_VICTIM8_SWIM  	22
#define L4_MOVE_ENEMY_TOOTH1_SWIM 	23
#define L4_MOVE_ENEMY_TOOTH2_SWIM 	24
#define L4_MOVE_ENEMY_TOOTH3_SWIM 	25
#define L4_MOVE_ENEMY_SWARM1_SWIM 	26
#define L4_MOVE_ENEMY_SWARM2_SWIM 	27
#define L4_MOVE_FLASH1_SWIM 	28
#define L4_MOVE_FLASH2_SWIM 	29
#define L4_MOVE_ENEMY_STAR1_SWIM 	30
#define L4_MOVE_ENEMY_STAR2_SWIM 	31
#define L4_MOVE_ENEMY_RM1_SWIM 	32
#define L4_MOVE_ENEMY_RM2_SWIM 	33
#define L4_MOVE_GOAL_SWIM 		34

u16 l4_screenLoaded = 0;

u16 l4_objectCount = 28;
u16 l4_objectSwapCount = 115;
u16 l4_objectMoveCount = 35;
s8 l4_lastScreen = 2;

object l4_objects[28] = {{ 0,0,120, 396,28, 0,1,196,    0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// Rock bottom 1
						{  0,0,120, 396,28, 396,1,196,  0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},  	// Rock bottom 2
						{  0,0,200, 392,150, 0,6,60,    0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, 	// Wall 1
						{  0,0,200, 392,150, 392,6,60,  0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},   // Wall 2
						{  0,0,160,  396,28, 0,4,48,  0, 29,  ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1}, 	// Rock Top 1
						{  0,0,160,  396,28, 396,4,48,0, 28,  ANI_UPDATE_FULL, ANI_TYPE_MOVING, 1},   	// Rock Top 2
						{  0,0,120, 389,48, 0,0,0,     1, 5,  ANI_UPDATE_FULL, ANI_TYPE_FIXED, 1},   	// SCORE
						{  0,0,0, 39,57, 100,0,100,    1, 17, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1},   // PLAYER
						{408,0,0, 40,30, 410,0,50,     1, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 1
						{408,0,0, 40,30, 410,0,85,     1, 24, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 2
						{408,0,0, 40,30, 410,0,120,    1, 23, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 3
						{408,0,0, 40,30, 410,0,155,    1, 22, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 4
						{408,0,0, 40,30, 410,0,50,     1, 21, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 5
						{408,0,0, 40,30, 410,0,85,     1, 20, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 6
						{408,0,0, 40,30, 410,0,120,    1, 19, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 7
						{408,0,0, 40,30, 410,0,155,    1, 18, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// victim 8
						{0,0,260, 72,72, 410,0,100,    2, 16, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy toothfish 1
						{0,0,260, 72,72, 410,0,100,    2, 15, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy toothfish 2
						{0,0,250, 72,72, 410,0,100,    2, 14, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy toothfish 3
						{0,0,120, 78,78, 410,0,100,    2, 13, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy swarm 1
						{0,0,120, 78,78, 410,0,100,    2, 12, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy swarm 2
						{0,0,60,  60,45, 410,0,100,    2, 11, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy flash fish 1
						{0,0,60,  60,45, 410,0,100,    2, 10, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy flash fish 2
						{0,0,0,   55,55, 410,0,100,    2,  9, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy starfish 1
						{0,0,0,   55,55, 410,0,100,    2,  8, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy starfish 2
						{240,0,121, 39,100, 410,0,125, 3,  7,  ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy real mine 1
						{240,0,121, 39,100, 410,0,150, 3,  6,  ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0}, 	// enemy real mine 2
						{  0,0,240, 143,60, 410,-1,100,  3, 4, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 0},   		// GOAL
						};  	
						
movement l4_objectmove[35] = {{-393,1,196, 3,1,1,0, ANI_MOVE_STRAIGHT,L4_OBJ_ROCKB1, 1, 396,1,196,1},
							 {-393, 1,196, 3,1,1,0, ANI_MOVE_STRAIGHT,L4_OBJ_ROCKB2, 1, 396,1,196,1},
							 {-391,6,60,   1,1,1,0, ANI_MOVE_STRAIGHT,L4_OBJ_WALL1, 1, 392,6,60,1},
							 {-391,6,60,   1,1,1,0, ANI_MOVE_STRAIGHT,L4_OBJ_WALL2, 1, 392,6,60,1},
							 {-393,4,48,  3,1,1,0, ANI_MOVE_STRAIGHT,L4_OBJ_ROCKT1, 1, 396,4,48,1},
							 {-393,4,48,  3,1,1,0, ANI_MOVE_STRAIGHT,L4_OBJ_ROCKT2, 1, 396,4,48,1},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_PLAYER,0, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM1,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM2,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM3,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM4,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM1,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM2,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM3,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM4,  2, 410,0,155,0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM5,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM6,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM7,2, 0,0,0, 0},
							 {0,0,250,     2,1,2,0, ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM8,2, 0,0,0, 0},
							 {-80,0,50,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM5,  2, 410,0,50,0},
							 {-80,0,85,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM6,  2, 410,0,85,0},
							 {-80,0,120,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM7,  2, 410,0,120,0},
							 {-80,0,155,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_VICTIM8,  2, 410,0,155,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_TOOTH1,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_TOOTH2,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_TOOTH3,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_SWARM1,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_SWARM2,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_FLASH1,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_FLASH2,  2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_STAR1,   2, 200,0,100,0},
							 {-80,0,100,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_STAR2,   2, 200,0,100,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_RM1, 2, 410,0,125,0},
							 {-110,0,125,2,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_ENEMY_RM2, 2, 410,0,125,0},
							 {-110,0,125,1,1,1,0,ANI_MOVE_STRAIGHT,L4_OBJ_GOAL, 	 2, 410,0,125,0},
							};
							 
swap l4_objectswap[117] = {{40,0,0, 0,0,0, 10, 10, 1, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 1}, 		//player swim animation
						 {80,0,0, 0,0,0, 10, 10, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 2},
						 {120,0,0, 0,0,0, 10, 10, 0, L4_OBJ_PLAYER, ANI_SWAP_SWITCH, 3},
						 {0,0,0, 0,0,0, 10, 10, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {160,0,0, 0,0,0, 2, 2, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 5}, 		//player eat animation
						 {200,0,0, 0,0,0, 2, 2, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 6},
						 {240,0,0, 0,0,0, 2, 2, 0, L4_OBJ_PLAYER, ANI_SWAP_SWITCH, 7},
						 {280,0,0, 0,0,0, 2, 2, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 8},
						 {320,0,0, 0,0,0, 2, 2, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 9},
						 {360,0,0, 0,0,0, 2, 2, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 0},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 11}, 		//player death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 12},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_PLAYER, ANI_SWAP_SWITCH, 13},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_PLAYER,  ANI_SWAP_SWITCH, 10},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM1, ANI_SWAP_SWITCH, 15}, 		//victim 1 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM1, ANI_SWAP_SWITCH, 14},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 17}, 		//victim 1 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 18},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM1, ANI_SWAP_SWITCH, 19},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM1,  ANI_SWAP_SWITCH, 16},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM2, ANI_SWAP_SWITCH, 21}, 		//victim 2 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM2, ANI_SWAP_SWITCH, 20},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 23}, 		//victim 2 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 24},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM2, ANI_SWAP_SWITCH, 25},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM2,  ANI_SWAP_SWITCH, 22},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM3, ANI_SWAP_SWITCH, 27}, 		//victim 3 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM3, ANI_SWAP_SWITCH, 26},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 29}, 		//victim 3 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 30},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM3, ANI_SWAP_SWITCH, 31},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM3,  ANI_SWAP_SWITCH, 28},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM4, ANI_SWAP_SWITCH, 33}, 		//victim 4 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM4, ANI_SWAP_SWITCH, 32},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 35}, 		//victim 4 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 36},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM4, ANI_SWAP_SWITCH, 37},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM4,  ANI_SWAP_SWITCH, 34},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM5, ANI_SWAP_SWITCH, 39}, 		//victim 5 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM5, ANI_SWAP_SWITCH, 38},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 41}, 		//victim 5 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 42},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM5, ANI_SWAP_SWITCH, 43},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM5,  ANI_SWAP_SWITCH, 40},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM6, ANI_SWAP_SWITCH, 45}, 		//victim 6 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM6, ANI_SWAP_SWITCH, 44},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 47}, 		//victim 6 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 48},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM6, ANI_SWAP_SWITCH, 49},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM6,  ANI_SWAP_SWITCH, 46},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM7, ANI_SWAP_SWITCH, 51}, 		//victim 7 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM7, ANI_SWAP_SWITCH, 50},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 53}, 		//victim 7 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 54},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM7, ANI_SWAP_SWITCH, 55},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM7,  ANI_SWAP_SWITCH, 52},
						 {448,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM8, ANI_SWAP_SWITCH, 57}, 		//victim 8 swim animation 
						 {408,0,0, 0,0,0, 20, 20, 0, L4_OBJ_VICTIM8, ANI_SWAP_SWITCH, 56},
						 {0,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 59}, 		//victim 8 death animation
						 {40,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 60},
						 {80,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM8, ANI_SWAP_SWITCH, 61},
						 {120,0,58, 0,0,0, 5, 5, 0, L4_OBJ_VICTIM8,  ANI_SWAP_SWITCH, 58},
						 {80,0,260,  0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 63},  //enemy toothfish 1 swim
						 {0,0,260,   0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 64},  
						 {160,0,260, 0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 62},  
						 {320,0,260,  0,0,0, 0, 10, 0, L4_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 66},  //enemy toothfish 1 kill
						 {400,0,260,  0,0,0, 0, 20, 0, L4_OBJ_ENEMY_TOOTH1, ANI_SWAP_SWITCH, 62},  
						 {80,0,260,  0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH2, ANI_SWAP_SWITCH, 68},  //enemy toothfish 2 swim
						 {0,0,260,   0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH2, ANI_SWAP_SWITCH, 69},  
						 {160,0,260, 0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH2, ANI_SWAP_SWITCH, 67},  
						 {320,0,260,  0,0,0, 0, 10, 0, L4_OBJ_ENEMY_TOOTH2, ANI_SWAP_SWITCH, 71},  //enemy toothfish 2 kill
						 {400,0,260,  0,0,0, 0, 20, 0, L4_OBJ_ENEMY_TOOTH2, ANI_SWAP_SWITCH, 67},  
						 {80,0,260,  0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH3, ANI_SWAP_SWITCH, 73},  //enemy toothfish 3 swim
						 {0,0,260,   0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH3, ANI_SWAP_SWITCH, 74},  
						 {160,0,260, 0,0,0, 10, 10, 0, L4_OBJ_ENEMY_TOOTH3, ANI_SWAP_SWITCH, 72},  
						 {320,0,260,  0,0,0, 0, 10, 0, L4_OBJ_ENEMY_TOOTH3, ANI_SWAP_SWITCH, 76},  //enemy toothfish 3 kill
						 {400,0,260,  0,0,0, 0, 20, 0, L4_OBJ_ENEMY_TOOTH3, ANI_SWAP_SWITCH, 72},  
						 {80,0,120,  0,0,0, 0, 20, 0, L4_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 78},  //enemy swarm 1 swim
						 {0,0,120,   0,0,0, 0, 20, 0, L4_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 77},  
						 {160,0,120,   0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 80},  //enemy swarm 1 kill
						 {240,0,120,   0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 81},
						 {160,0,120,   0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 82},
						 {0,0,120,     0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM1, ANI_SWAP_SWITCH, 79},
						 {80,0,120,  0,0,0, 0, 20, 0, L4_OBJ_ENEMY_SWARM2, ANI_SWAP_SWITCH, 84},  //enemy swarm 2 swim
						 {0,0,120,   0,0,0, 0, 20, 0, L4_OBJ_ENEMY_SWARM2, ANI_SWAP_SWITCH, 83},  
						 {160,0,120,   0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM2, ANI_SWAP_SWITCH, 86},  //enemy swarm 2 kill
						 {240,0,120,   0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM2, ANI_SWAP_SWITCH, 87},
						 {160,0,120,   0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM2, ANI_SWAP_SWITCH, 88},
						 {0,0,120,     0,0,0, 0, 5, 0, L4_OBJ_ENEMY_SWARM2, ANI_SWAP_SWITCH, 85},
						 {80,0,60,   0,0,0, 0, 10, 0, L4_OBJ_FLASH1, ANI_SWAP_SWITCH, 90},  //enemy flash 1 swim
						 {0,0,60,    0,0,0, 0, 10, 0, L4_OBJ_FLASH1, ANI_SWAP_SWITCH, 89},
						 {240,0,60,    0,0,0, 0, 40, 0, L4_OBJ_FLASH1, ANI_SWAP_SWITCH, 89},  //enemy flash 1 kill
						 {80,0,60,   0,0,0, 0, 10, 0, L4_OBJ_FLASH2, ANI_SWAP_SWITCH, 93},  //enemy flash 2 swim
						 {0,0,60,    0,0,0, 0, 10, 0, L4_OBJ_FLASH2, ANI_SWAP_SWITCH, 92},
						 {240,0,60,    0,0,0, 0, 40, 0, L4_OBJ_FLASH2, ANI_SWAP_SWITCH, 92},  //enemy flash 2 kill
						 {80,0,0,   0,0,0, 0, 4, 1, L4_OBJ_ENEMY_STAR1, ANI_SWAP_SWITCH, 96},  //enemy starfish 1 swim 
						 { 0,0,0,   0,0,0, 0, 4, 0, L4_OBJ_ENEMY_STAR1, ANI_SWAP_SWITCH, 95},
						 {80,0,0,   0,0,0, 0, 8, 0, L4_OBJ_ENEMY_STAR1, ANI_SWAP_SWITCH, 98},   //enemy starfish 1 kill 
						 { 0,0,0,   0,0,0, 0, 8, 0, L4_OBJ_ENEMY_STAR1, ANI_SWAP_SWITCH, 97},
						 {80,0,0,   0,0,0, 0, 4, 0, L4_OBJ_ENEMY_STAR2, ANI_SWAP_SWITCH, 100},  //enemy starfish 2 swim 
						 { 0,0,0,   0,0,0, 0, 4, 0, L4_OBJ_ENEMY_STAR2, ANI_SWAP_SWITCH, 99},
						 {80,0,0,   0,0,0, 0, 8, 0, L4_OBJ_ENEMY_STAR2, ANI_SWAP_SWITCH, 102},   //enemy starfish 2 kill 
						 { 0,0,0,   0,0,0, 0, 8, 0, L4_OBJ_ENEMY_STAR2, ANI_SWAP_SWITCH, 101},
						 {240,0,121, 0,0,0, 0, 30, 0, L4_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 103},  //enemy real mine 1 swim animation 
						 {80,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 105},	//enemy real mine 1 kill animation 
						 {120,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 106},	
						 {160,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 107},	
						 {200,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 108},
						 {300,0,121, 0,0,0, 0, 50, 0, L4_OBJ_ENEMY_RM1, ANI_SWAP_SWITCH, 108},
						 {240,0,121, 0,0,0, 0, 30, 0, L4_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 109},  //enemy real mine 2 swim animation 
						 {80,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 111},	//enemy real mine 2 kill animation 
						 {120,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 112},	
						 {160,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 113},	
						 {200,0,121, 0,0,0, 0, 5, 0, L4_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 114},
						 {300,0,121, 0,0,0, 0, 50, 0, L4_OBJ_ENEMY_RM2, ANI_SWAP_SWITCH, 114},
						 {144,0,240, 0,0,0, 0, 20, 0, L1_OBJ_GOAL, ANI_SWAP_SWITCH, 116},			//GOAL swim
						 {  0,0,240, 0,0,0, 0, 20, 0, L1_OBJ_GOAL, ANI_SWAP_SWITCH, 115},
						 };

void l4_reset()
{
	u16 i=0;
	l4_screenLoaded = 0;
	
	for(i=0; i<l4_objectCount; i++)
	{
		l4_objects[i].update = ANI_UPDATE_FULL;
		if(i>7)
		{
			l4_objects[i].active=0;
			l4_objects[i].x=410;
		}
	}
	
	for(i=0; i<l4_objectMoveCount; i++)
	{
		if(i>5)
		{
			l4_objectmove[i].active=0;
		}
	}
	
	for(i=0; i<l4_objectSwapCount; i++)
	{
		if(i>1)
		{
			l4_objectswap[i].active=0;
		}
	}
	
	main_pause = 1;
	vbDisplayHide();
}
						 
void l4_setUpScreen()
{
	if(l4_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)L4BGCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)L4BGMAP, 8192);
		
		copymem((void*)CharSeg1, (void*)L1FISHCHAR, 8192); 
		copymem((void*)BGMap(1), (void*)L1FISHMAP, 8192);
		
		copymem((void*)CharSeg2, (void*)L4ENEMYCHAR, 8192); 
		copymem((void*)BGMap(2), (void*)L4ENEMYMAP, 8192);
		
		ani_objectCnt = l4_objectCount;
		ani_objects = l4_objects;
		
		ani_objectMoveCnt = l4_objectMoveCount;
		ani_objectSwapCnt = l4_objectSwapCount;
		ani_objectmove = l4_objectmove;
		ani_objectswap = l4_objectswap;
		ani_lastScreen = l4_lastScreen;
		
		//this is game code and shouldn't be here (fix this!)
		ani_activateObject(L4_OBJ_PLAYER);
		ani_activateSwap(L4_SWAP_PLAYER_SWIM);
		ani_objectswap[L4_SWAP_PLAYER_SWIM].delay = 0;
		
		mp_playerStop();
		mp_loadSong_inv3v13a();
		mp_playerStart();
		
		ani_swapObjects();
		ani_moveObjects();
		ani_drawObjects();
		
		main_pause = 0;
		vbDisplayShow();
		
		l4_screenLoaded = 1;
	}

}