#include "levelmenu.h"

u8 lm_blocked = 0;
u8 lm_start  = 1;
u8 lm_statusR = 0;
u8 lm_statusL = 0;
u8 lm_statusStart = 0;

u16 lm_frameCount=0;

u8 lm_csLevel1Map = 0;
u8 lm_csLevel2Map = 0;
u8 lm_csLevel3Map = 0;
u8 lm_csLevel4Map = 0;
//u16 lm_frameCountActive=0;
u8 lm_levelSelected = LM_OBJ_LEVEL1;
u8 lm_levelLeft = LM_OBJ_LEVEL2;
u8 lm_levelRight = LM_OBJ_LEVEL4;
u8 lm_levelBack = LM_OBJ_LEVEL3;
u8 lm_startUp=1;

u16 lm_getScoreFromSRAM(u16 offset)
{
	u16 score = 0;
	score = mem_getFromSRAM(offset) << 8;
	score = ( score | mem_getFromSRAM(offset+1));
	return score;
}

void lm_setGameScore(u16 score)
{
	char * buffer;
		
	if(score > 999)
	{
		score = 999;
		//game_lastScore = score;
	}
	
	if(score < 10)
	{
		buffer = itoa(score,10,1);
		lm_scoreText[8] = buffer[0];
		lm_scoreText[7] = '0';
		lm_scoreText[6] = '0';
	}
	else if(score < 100)
	{
		buffer = itoa(score,10,2);
		lm_scoreText[8] = buffer[1];
		lm_scoreText[7] = buffer[0];
		lm_scoreText[6] = '0';
	}
	else if(score < 1000)
	{
		buffer = itoa(score,10,3);
		lm_scoreText[8] = buffer[2];
		lm_scoreText[7] = buffer[1];
		lm_scoreText[6] = buffer[0];
	}
}

void lm_updateText()
{
	u16 score=0;
				
	if(lm_levelSelected==LM_OBJ_LEVEL1)
	{
		score = lm_getScoreFromSRAM(4);
		lm_setGameScore(score);
		vbTextOutS(11, 0, 0, lm_scoreText);
		vbTextOutS(12, 0, 0, lm_stageText1);
		WORLD_SIZE(26,96,16);
		WORLD_GSET(26,144,0,175);
	}
	else if(lm_levelSelected==LM_OBJ_LEVEL2)
	{
		score = lm_getScoreFromSRAM(6);
		lm_setGameScore(score);
		vbTextOutS(11, 0, 0, lm_scoreText);
		vbTextOutS(12, 0, 0, lm_stageText2);
		WORLD_SIZE(26,128,16);
		WORLD_GSET(26,128,0,175);
	}
	else if(lm_levelSelected==LM_OBJ_LEVEL3)
	{
		score = lm_getScoreFromSRAM(8);
		lm_setGameScore(score);
		vbTextOutS(11, 0, 0, lm_scoreText);
		vbTextOutS(12, 0, 0, lm_stageText3);
		WORLD_SIZE(26,152,16);
		WORLD_GSET(26,116,0,175);
	}
	else if(lm_levelSelected==LM_OBJ_LEVEL4)
	{
		score = lm_getScoreFromSRAM(10);
		lm_setGameScore(score);
		vbTextOutS(11, 0, 0, lm_scoreText);
		vbTextOutS(12, 0, 0, lm_stageText4);
		WORLD_SIZE(26,88,16);
		WORLD_GSET(26,148,0,175);
	}
}

u8 lm_display(HWORD pad)
{
	u8 i=0;
	
	if(lm_startUp==1)
	{
		lm_updateText();
		lm_startUp=0;
	}
				
	if(lm_blocked==0)
	{
		if((pad&K_LR || pad&K_RR ) && lm_statusR==0)
		{
			lm_statusL=1;
		}
		else if((pad&K_LL || pad&K_RL ) && lm_statusL==0)
		{
			lm_statusR=1;
		}
		else if((pad&K_A || pad&K_B || pad&K_STA  || pad&K_SEL) && lm_statusStart==0)
		{
			lm_statusStart=1;
		}
		else if(!(pad&K_ANY) && lm_statusStart==1)
		{
			if(lm_blocked==0)
			{
				lm_statusStart = 0;
				lm_statusR=0;
				lm_statusL=0;
				lm_start=0;
				lm_startUp=1;
						
				if(lm_levelSelected==LM_OBJ_LEVEL1)
				{
					return STATUS_LEVEL1;
				}
				else if(lm_levelSelected==LM_OBJ_LEVEL2)
				{
					return STATUS_LEVEL2;
				}
				else if(lm_levelSelected==LM_OBJ_LEVEL3)
				{
					return STATUS_LEVEL3;
				}
				else if(lm_levelSelected==LM_OBJ_LEVEL4)
				{
					return STATUS_LEVEL4;
				}
				
				return STATUS_STARTSCREEN;
				//return STATUS_GAMEOVERSCREEN;
			}
		}
		else if(!(pad&K_ANY) && lm_statusR==1)
		{
			suse_playSound(sndMenuSoundR);
			lm_frameCount = 0;
			lm_blocked=1;
			
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].target_x = ani_objects[LM_OBJ_LEVEL4].x;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].target_x = ani_objects[LM_OBJ_LEVEL1].x;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].target_x = ani_objects[LM_OBJ_LEVEL2].x;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].target_x = ani_objects[LM_OBJ_LEVEL3].x;
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].target_p = ani_objects[LM_OBJ_LEVEL4].p;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].target_p = ani_objects[LM_OBJ_LEVEL1].p;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].target_p = ani_objects[LM_OBJ_LEVEL2].p;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].target_p = ani_objects[LM_OBJ_LEVEL3].p;
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].target_y = ani_objects[LM_OBJ_LEVEL4].y;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].target_y = ani_objects[LM_OBJ_LEVEL1].y;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].target_y = ani_objects[LM_OBJ_LEVEL2].y;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].target_y = ani_objects[LM_OBJ_LEVEL3].y;
			
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].active = 1;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].active = 1;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].active = 1;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].active = 1;
			
			/*ani_objectmove[lm_levelSelected].delay = 10;
			ani_objectmove[lm_levelLeft].delay = 45;
			ani_objectmove[lm_levelBack].delay = 70;
			ani_objectmove[lm_levelRight].delay = 95;*/
			
			ani_objectmove[lm_levelSelected].delay = 5;
			ani_objectmove[lm_levelLeft].delay = 20;
			ani_objectmove[lm_levelBack].delay = 32;
			ani_objectmove[lm_levelRight].delay = 44;
			
			ani_objects[LM_OBJ_LEVEL1].update = ANI_UPDATE_FULL;
			ani_objects[LM_OBJ_LEVEL2].update = ANI_UPDATE_FULL;
			ani_objects[LM_OBJ_LEVEL3].update = ANI_UPDATE_FULL;
			ani_objects[LM_OBJ_LEVEL4].update = ANI_UPDATE_FULL;
			
			ani_objects[LM_OBJ_LEVEL1].active = 1;
			ani_objects[LM_OBJ_LEVEL2].active = 1;
			ani_objects[LM_OBJ_LEVEL3].active = 1;
			ani_objects[LM_OBJ_LEVEL4].active = 1;
			
			lm_csLevel1Map = ani_objects[LM_OBJ_LEVEL1].bgMap;
			lm_csLevel2Map = ani_objects[LM_OBJ_LEVEL2].bgMap;
			lm_csLevel3Map = ani_objects[LM_OBJ_LEVEL3].bgMap;
			lm_csLevel4Map = ani_objects[LM_OBJ_LEVEL4].bgMap;
		}
		else if(!(pad&K_ANY) && lm_statusL==1)
		{
			suse_playSound(sndMenuSoundL);
			lm_frameCount = 0;
			lm_blocked=1;
			
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].target_x = ani_objects[LM_OBJ_LEVEL2].x;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].target_x = ani_objects[LM_OBJ_LEVEL3].x;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].target_x = ani_objects[LM_OBJ_LEVEL4].x;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].target_x = ani_objects[LM_OBJ_LEVEL1].x;
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].target_p = ani_objects[LM_OBJ_LEVEL2].p;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].target_p = ani_objects[LM_OBJ_LEVEL3].p;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].target_p = ani_objects[LM_OBJ_LEVEL4].p;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].target_p = ani_objects[LM_OBJ_LEVEL1].p;
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].target_y = ani_objects[LM_OBJ_LEVEL2].y;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].target_y = ani_objects[LM_OBJ_LEVEL3].y;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].target_y = ani_objects[LM_OBJ_LEVEL4].y;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].target_y = ani_objects[LM_OBJ_LEVEL1].y;
			
			ani_objectmove[LM_OBJ_LEVEL1_MOVE].active = 1;
			ani_objectmove[LM_OBJ_LEVEL2_MOVE].active = 1;
			ani_objectmove[LM_OBJ_LEVEL3_MOVE].active = 1;
			ani_objectmove[LM_OBJ_LEVEL4_MOVE].active = 1;
			
			/*ani_objectmove[lm_levelSelected].delay = 10;
			ani_objectmove[lm_levelRight].delay = 45;
			ani_objectmove[lm_levelBack].delay = 70;
			ani_objectmove[lm_levelLeft].delay = 95;*/
			
			ani_objectmove[lm_levelSelected].delay = 5;
			ani_objectmove[lm_levelRight].delay = 17;
			ani_objectmove[lm_levelBack].delay = 29;
			ani_objectmove[lm_levelLeft].delay = 41;
			
			ani_objects[LM_OBJ_LEVEL1].update = ANI_UPDATE_FULL;
			ani_objects[LM_OBJ_LEVEL2].update = ANI_UPDATE_FULL;
			ani_objects[LM_OBJ_LEVEL3].update = ANI_UPDATE_FULL;
			ani_objects[LM_OBJ_LEVEL4].update = ANI_UPDATE_FULL;
			
			ani_objects[LM_OBJ_LEVEL1].active = 1;
			ani_objects[LM_OBJ_LEVEL2].active = 1;
			ani_objects[LM_OBJ_LEVEL3].active = 1;
			ani_objects[LM_OBJ_LEVEL4].active = 1;
			
			lm_csLevel1Map = ani_objects[LM_OBJ_LEVEL1].bgMap;
			lm_csLevel2Map = ani_objects[LM_OBJ_LEVEL2].bgMap;
			lm_csLevel3Map = ani_objects[LM_OBJ_LEVEL3].bgMap;
			lm_csLevel4Map = ani_objects[LM_OBJ_LEVEL4].bgMap;
		}
	}
	else if(lm_blocked==1)
	{
		if(lm_statusR==1 || lm_statusL==1 )
		{
			lm_frameCount++;
			//if(lm_frameCount==110)
			if(lm_frameCount==55)
			{
				if(lm_statusR==1)
				{
					ani_objects[LM_OBJ_LEVEL1].bgMap = lm_csLevel4Map;
					ani_objects[LM_OBJ_LEVEL2].bgMap = lm_csLevel1Map;
					ani_objects[LM_OBJ_LEVEL3].bgMap = lm_csLevel2Map;
					ani_objects[LM_OBJ_LEVEL4].bgMap = lm_csLevel3Map;
				}
				else
				{
					ani_objects[LM_OBJ_LEVEL1].bgMap = lm_csLevel2Map;
					ani_objects[LM_OBJ_LEVEL2].bgMap = lm_csLevel3Map;
					ani_objects[LM_OBJ_LEVEL3].bgMap = lm_csLevel4Map;
					ani_objects[LM_OBJ_LEVEL4].bgMap = lm_csLevel1Map;
				}
				ani_objects[LM_OBJ_LEVEL1].update = ANI_UPDATE_FULL;
				ani_objects[LM_OBJ_LEVEL2].update = ANI_UPDATE_FULL;
				ani_objects[LM_OBJ_LEVEL3].update = ANI_UPDATE_FULL;
				ani_objects[LM_OBJ_LEVEL4].update = ANI_UPDATE_FULL;
			}
			//else if(lm_frameCount==200)
			else if(lm_frameCount==110)
			{
				lm_frameCount=0;
				lm_statusR=0;
				lm_statusL=0;
				lm_blocked=0;
				
				for(i=0; i<ani_objectCnt; i++)
				{
					if(ani_objects[i].bgMap==28)
					{
						lm_levelSelected=i;
					}
					else if(ani_objects[i].bgMap==30)
					{
						lm_levelLeft=i;
					}
					else if(ani_objects[i].bgMap==29)
					{
						lm_levelRight=i;
					}
					else if(ani_objects[i].bgMap==31)
					{
						lm_levelBack=i;
					}
				}
				
				lm_updateText();
				
			}
		}
		else
		{
			lm_blocked=0;
		}
	}
	
	return STATUS_LEVELSCREEN;
}