#include "../img/levelmenumap.h"
#include "../img/levelmenuchar.h"

#define LM_OBJ_LEVEL1 0
#define LM_OBJ_LEVEL2 1
#define LM_OBJ_LEVEL3 2
#define LM_OBJ_LEVEL4 3

#define LM_OBJ_LEVEL1_MOVE 0
#define LM_OBJ_LEVEL2_MOVE 1
#define LM_OBJ_LEVEL3_MOVE 2
#define LM_OBJ_LEVEL4_MOVE 3

u16 lm_screenLoaded = 0;

u16 lm_objectCount = 4;
u16 lm_objectSwapCount = 0;
u16 lm_objectMoveCount = 4;
u8 lm_lastScreen = 24;
char lm_selectText[13] = "STAGE SELECT";
char lm_stageText1[13] = "CLASSIC FISH";
char lm_stageText2[17] = "SUPER FISH WORLD";
char lm_stageText3[20] = "REVENGE OF THE FISH";
char lm_stageText4[12] = "PHISH TAHKO";
char lm_scoreText[10] = "SCORE 000";

object lm_objects[4] = {{  0,0,0, 143,66,   120,0,106, 0, 28, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 0},  // level 1
						{  0,0,80, 143,66,    0,6,70, 0, 30, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 0},  // level 2
						{  0,0,160, 143,66, 120,10,50, 0, 31, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 0},  // level 3
						{  0,0,240, 143,66, 250,6,70, 0, 29, ANI_UPDATE_FULL, ANI_TYPE_MOVING, 0},  // level 4
						};  	
						
movement lm_objectmove[4] = {
							{0,0,0,2,2,2, 0, ANI_MOVE_STRAIGHT,LM_OBJ_LEVEL1, 2, 0,0,0,0},
							{0,0,0,2,2,2, 0, ANI_MOVE_STRAIGHT,LM_OBJ_LEVEL2, 2, 0,0,0,0},
							{0,0,0,2,2,2, 0, ANI_MOVE_STRAIGHT,LM_OBJ_LEVEL3, 2, 0,0,0,0},
							{0,0,0,2,2,2, 0, ANI_MOVE_STRAIGHT,LM_OBJ_LEVEL4, 2, 0,0,0,0},
							};
							 
swap lm_objectswap[1] = {{40,0,0, 0,0,0, 10, 10, 1, 0,  ANI_SWAP_SWITCH, 0},};

						 
void lm_reset()
{
	u8 i=0;
	lm_screenLoaded = 0;
	for(i=0; i<lm_objectCount; i++)
	{
		lm_objects[i].update = ANI_UPDATE_FULL;
	}
	
	for(i=0; i < 32; i++)
	{
		WORLD_HEAD(i,WRLD_ON | WRLD_BGMAP | 0);
		WORLD_GSET(i,0,0,0);
		WORLD_MSET(i,0,0,0);
		WORLD_SIZE(i,0,0);
	}
	main_pause = 1;
	vbDisplayHide();
}

void lm_setUpScreen()
{
	if(lm_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)LEVELMENUCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)LEVELMENUMAP, 8192);
		
		mp_playerStop();
		mp_loadSong_inv3v03d();
		mp_playerStart();
		
		ani_objectCnt = lm_objectCount;
		ani_objects = lm_objects;
		
		ani_objectMoveCnt = lm_objectMoveCount;
		ani_objectSwapCnt = lm_objectSwapCount;
		ani_objectmove = lm_objectmove;
		ani_objectswap = lm_objectswap;
		ani_lastScreen = lm_lastScreen;
		
		ani_drawObjects();
		
		
		
		WORLD_HEAD(27,WRLD_ON | WRLD_BGMAP | 13);
		WORLD_GSET(27,144,0,20);
		WORLD_MSET(27,0,0,0);
		WORLD_SIZE(27,96,16);
		vbTextOutS(13, 0, 0, lm_selectText);
		
		WORLD_HEAD(26,WRLD_ON | WRLD_BGMAP | 12);
		WORLD_GSET(26,144,0,175);
		WORLD_MSET(26,0,0,0);
		WORLD_SIZE(26,152,16);
		vbTextOutS(12, 0, 0, lm_stageText1);
		
		WORLD_HEAD(25,WRLD_ON | WRLD_BGMAP | 11);
		WORLD_GSET(25,156,0,195);
		WORLD_MSET(25,0,0,0);
		WORLD_SIZE(25,72,16);
		vbTextOutS(11, 0, 0, lm_scoreText);
		
		main_pause = 0;
		vbDisplayShow();
		
		lm_screenLoaded = 1;
	}

}