#include "../img/smmap.h"
#include "../img/smchar.h"

#define SM_OBJ_LOGO 0
#define SM_OBJ_FISH0 1
#define SM_OBJ_FISH1 2
#define SM_OBJ_FISH2 3
#define SM_OBJ_FISH3 4
#define SM_OBJ_FISH4 5

u16 sm_screenLoaded = 0;

u16 sm_objectCount = 6;
u16 sm_objectSwapCount = 5;
u16 sm_objectMoveCount = 5;
u8 sm_lastScreen = 20;
char sm_startText[12] = "PRESS START";
char sm_demoText[5] = "    ";

object sm_objects[6] = {{  0,0,0, 152,55, 116,-15,84, 0, 31, ANI_UPDATE_FULL, ANI_TYPE_FIXED, 1},  // logo
						{154,0,0, 40, 30, 410,-20,30, 0, 29, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, // fish 0
						{154,0,0, 40, 30, 410,-20,70, 0, 28, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, // fish 1
						{154,0,0, 40, 30, 410,-20,110, 0, 27, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, // fish 2
						{154,0,0, 40, 30, 410,-20,130, 0, 26, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, // fish 3
						{154,0,0, 40, 30, 410,-20,170, 0, 25, ANI_UPDATE_FULL, ANI_TYPE_MOVING_A, 1}, // fish 4
						};  	
						
movement sm_objectmove[5] = {{-80,-20,30,1,1,1,0,ANI_MOVE_STRAIGHT,SM_OBJ_FISH0,1,410,-20,30,1},
							 {-80,-20,70,1,1,1,240,ANI_MOVE_STRAIGHT,SM_OBJ_FISH1,1,410,-20,70,1},
							 {-80,-20,110,1,1,1,120,ANI_MOVE_STRAIGHT,SM_OBJ_FISH2,1,410,-20,110,1},
							 {-80,-20,130,1,1,1,60,ANI_MOVE_STRAIGHT,SM_OBJ_FISH3,1,410,-20,130,1},
							 {-80,-20,170,1,1,1,360,ANI_MOVE_STRAIGHT,SM_OBJ_FISH4,1,410,-20,170,1},							 
							};
							 
swap sm_objectswap[5] = {{194,0,0, 0,0,0, 0, 20, 1, SM_OBJ_FISH0, ANI_SWAP_BACK, 0},
						 {194,0,0, 0,0,0, 5, 20, 1, SM_OBJ_FISH1, ANI_SWAP_BACK, 0},
						 {194,0,0, 0,0,0, 10, 20, 1, SM_OBJ_FISH2,ANI_SWAP_BACK, 0},
						 {194,0,0, 0,0,0, 0, 20, 1, SM_OBJ_FISH3, ANI_SWAP_BACK, 0},
						 {194,0,0, 0,0,0, 5, 20, 1, SM_OBJ_FISH4, ANI_SWAP_BACK, 0},
						 };

						 
void sm_reset()
{
	u8 i=0;
	sm_screenLoaded = 0;
	for(i=0; i<sm_objectCount; i++)
	{
		sm_objects[i].update = ANI_UPDATE_FULL;
	}
	main_pause = 1;
	vbDisplayHide();
}

void sm_setUpScreen()
{
	if(sm_screenLoaded==0)
	{
		copymem((void*)CharSeg0, (void*)SMCHAR, 8192); 
		copymem((void*)BGMap(0), (void*)SMMAP, 8192);
		
		mp_playerStop();
		mp_loadSong_inv3v01c();
		mp_playerStart();
		
		ani_objectCnt = sm_objectCount;
		ani_objects = sm_objects;
		
		ani_objectMoveCnt = sm_objectMoveCount;
		ani_objectSwapCnt = sm_objectSwapCount;
		ani_objectmove = sm_objectmove;
		ani_objectswap = sm_objectswap;
		ani_lastScreen = sm_lastScreen;
		
		ani_drawObjects();
		
		WORLD_HEAD(30,WRLD_ON | WRLD_BGMAP | 1);
		WORLD_GSET(30,145,-17,170);
		WORLD_MSET(30,0,0,0);
		WORLD_SIZE(30,88,16);
		vbTextOutS(1, 0, 0, sm_startText);
		
		WORLD_HEAD(24,WRLD_ON | WRLD_BGMAP | 13);
		WORLD_GSET(24,0,0,0);
		WORLD_MSET(24,0,0,0);
		WORLD_SIZE(24,32,16);
		vbTextOutS(13, 0, 0, sm_demoText);
		
		WORLD_HEAD(23,WRLD_ON | WRLD_BGMAP | 13);
		WORLD_GSET(23,0,0,208);
		WORLD_MSET(23,0,0,0);
		WORLD_SIZE(23,32,16);
		vbTextOutS(13, 0, 0, sm_demoText);
		
		WORLD_HEAD(22,WRLD_ON | WRLD_BGMAP | 13);
		WORLD_GSET(22,352,0,0);
		WORLD_MSET(22,0,0,0);
		WORLD_SIZE(22,32,16);
		vbTextOutS(13, 0, 0, sm_demoText);
		
		WORLD_HEAD(21,WRLD_ON | WRLD_BGMAP | 13);
		WORLD_GSET(21,352,0,208);
		WORLD_MSET(21,0,0,0);
		WORLD_SIZE(21,32,16);
		vbTextOutS(13, 0, 0, sm_demoText);
		
		main_pause = 0;
		vbDisplayShow();
		
		sm_screenLoaded = 1;
	}

}